/**
 * Created by gezhou on 6/29/2015.
 */
jQuery.sap.declare("sas.ea.util.DataLoaderUtil");
jQuery.sap.require("sas.ea.util.Step");
sas.ea.util.DataLoaderUtil = {

    genLabel: function ( sLabel, iCnt ) {

        return new sap.ui.layout.VerticalLayout({
            layoutData: new sap.ui.layout.GridData({ span:"L12 M12 S12" }),
            width: "100%",
            content: [
                sas.ea.util.JobResults.genBoldLabel( sLabel + ((iCnt > 0) ? " - " + iCnt : "") ),
                new sap.ui.commons.HorizontalDivider({ height:sap.ui.commons.HorizontalDividerHeight.Ruleheight })
            ]
        });

    },
    /* saspfj, TBDeleted*/
    genOutputGridItem: function ( oOut) {

        var sType = oOut.extension;
        var sData = oOut.name;
        var sLabel = oOut.name;//.replace(/_/gi, " "); // change underscores to spaces for better label wrapping
        var sUrl = window.location.origin + SC.RESULTS_PATH_DATA_LOADER + oOut.path;

        var sBase = "html/resources/sas/ea/images/";
        var sSrc = "";

        var lblClick = new sap.m.Label({
            height: SC.RESULTS_LABEL_HEIGHT, text: sLabel, wrapping: true,
            tooltip: oBundle.getText("Results.ClickPDF"),
            press: function () {
                window.open(sUrl, "");
            }
        });
        lblClick.attachBrowserEvent("click", function () {
            window.open(sUrl, "");
        });
        if ( sType === ".pdf" ) {
            return new sap.ui.layout.VerticalLayout({
                layoutData: new sap.ui.layout.GridData({span: "L2 M3 S6"}),
                content: [
                    new sas.hc.m.Button({
                        icon: sas.icons.HC.PDFFILE,//,
                        tooltip:    oBundle.getText("Results.ClickPDF"),
                        press:      function () {
                            window.open(sUrl, "");
                        }
                    }),
                    lblClick
                    //new sap.m.Label({ height:SC.RESULTS_LABEL_HEIGHT, text:sLabel, wrapping:true,
                    //    tooltip:    oBundle.getText("Results.ClickPDF"),
                    //    press:      function () { window.open(sUrl, "");  }
                    //})
                ]
            });
        }
        else if ((sType === ".sas7bdat") || (sType === ".sas7bndx")) {
            // for now treat datasets and views the same
            return new sap.ui.layout.VerticalLayout({
                layoutData: new sap.ui.layout.GridData({span: "L2 M3 S6"}),
                content: [
                    new sap.ui.layout.HorizontalLayout({
                        content: [
                            new sas.hc.m.Button({
                                icon: sas.icons.HC.SASDATASET,
                                tooltip: oBundle.getText("Results.ClickDATA"),
                                //tooltip:    "Click for Data Preview\n\nMember demographics data.  Each member should have matching records in SEA_SERVICES.\n\nOne record per member",
                                press: function () {
                                    sas.ea.util.DataLoaderUtil.showDataPreviewDialog(sData, sLabel, sUrl, true);
                                }
                            }),
                            new sap.ui.core.HTML({
                                content: "<span style='font-size:small; font-variant:small-caps;'>" + oOut.size + ((sType === "sas7bvew") ? " view" : "") + "</span>",  // saspfj, temp string until we get a real view icon
                                tooltip: oBundle.getText("Results.ClickToOpen"),
                                press: function () {
                                    sas.ea.util.Step.DataLoaderUtil(sData, sLabel, sUrl);
                                }
                            })
                        ]
                    }),
                    new sap.m.Label({
                        height: SC.RESULTS_LABEL_HEIGHT, text: sLabel, wrapping: true,
                        tooltip: oBundle.getText("Results.ClickDATA"),
                        press: function () {
                            sas.ea.util.Step.DataLoaderUtil(usData, sLabel, sUrl);
                        }
                    })
                ]
            });
        } else if (sType === "sas.log"){
            return new sap.ui.layout.VerticalLayout({
                layoutData: new sap.ui.layout.GridData({span: "L12 M12 S12"}),
                content: [
                    new sap.ui.core.HTML({
                        content:"<span>" + sMsg + "</span>"
                    })
                ]
            });
        } else {
            SEA.log("Render", "Unknown type for genStepOutputGridItem():" + sType);
            return new sap.m.Label({text: ""});
        }
    },


    genArtifactLabel: function ( sLabel, iCnt ) {

        /* saspfj, NEW,
         var sContent = "";

         // reports do not have leading vertical whitespace
         if ( sLabel !== oBundle.getText("StepPanels.Artfct.Rpts.lbl") ) {
         // saspfj, <br/> didn't seem to do anything, maybe <p/> will???
         sContent += "<p/>";
         }

         // everyone has a label
         sContent += "<span style='font-weight:bold;'>" + sLabel + "</span>";

         // execution info (aka log) does not have a viewer
         if ( sLabel !== oBundle.getText("StepPanels.Artfct.Exec.lbl") ) {
         sContent += "<a href='#' tabindex='0' onclick='alert(\"Yo Vern!\");return false;' style='float:right;'>" + sLabel + " viewer...</a>";
         }
         return new sap.ui.layout.VerticalLayout({
         layoutData: new sap.ui.layout.GridData({ span:"L12 M12 S12" }),
         width: "100%",
         content: [ new sap.ui.core.HTML({content:sContent}) ]
         });
         */

        return new sap.ui.layout.VerticalLayout({
            layoutData: new sap.ui.layout.GridData({ span:"L12 M12 S12" }),
            width: "100%",
            content: [
                new sap.ui.layout.HorizontalLayout({
                    content: [
                        sas.ea.util.JobResults.genBoldLabel( sLabel + ((iCnt > 0) ? " - " + iCnt : "") ),
                        new sap.m.ToolbarSpacer({width: "500px"}),
                        new sas.hc.m.Button({
                        icon: "sap-icon://hc/export",
                        enabled:false, press: function () {
                            sas.ea.util.DataLoaderUtil.dataExportHandler("temp");
                        }
                    })]
                }),
                new sap.ui.commons.HorizontalDivider({ height:sap.ui.commons.HorizontalDividerHeight.Ruleheight })

            ]
        });

    },

    genOutputGridItemLog: function (sMsg, sLink ) {

        // saspfj, refactor this
        if ( sLink != null ) {
            return new sap.ui.layout.VerticalLayout({
                layoutData: new sap.ui.layout.GridData({span: "L12 M12 S12"}),
                content: [
                    new sap.ui.core.HTML({
                        content:"<a href='" + sLink + "' target='_blank'>" + sMsg + "</a>"
                    })
                ]
            });
        } else {
            return new sap.ui.layout.VerticalLayout({
                layoutData: new sap.ui.layout.GridData({span: "L12 M12 S12"}),
                content: [
                    new sap.ui.core.HTML({
                        content:"<span>" + sMsg + "</span>"
                    })
                ]
            });
        }
    },
    dataExportHandler: function ( dataSetName) {
      //  alert( "TBD - Export SAS Data Set "+ dataSetName );
    },
    showDataPreviewDialog: function ( sData, sLabel, sUrl ) {
        //debugger;
        //alert("DataPreviewDialog\n\nfor\n\n" + sLabel + "\n\n" + sUrl)

        sas.ea.util.Step.dlgDataPreview.setTitle( oBundle.getText( "DataPreviewDialog.title" ) + " " + sLabel );
        sas.ea.util.Step.dlgDataPreview.sDataset = sData.substr( 0, sData.lastIndexOf('.') ); // strip off .sas7bdat
        sas.ea.util.Step.dlgDataPreview.bGeorge = true;

        // first strip off the front up to and including /files/sas
        var sPath = sUrl.substr( window.location.origin.length );
        sPath = sPath.substr( SC.RESULTS_PATH_DATA_LOADER.length );
        // now strip off the filename
        sPath = sPath.substr( 0, sPath.lastIndexOf('/') );
        sas.ea.util.Step.dlgDataPreview.sPath = sPath;

        // out with the old
        sas.ea.util.Step.dlgDataPreview.destroyContent();

        // shouldn't have to, but we do anyway
        if ( sas.ea.util.Step.jsviewDataPreviewDialog !== null ) {
            sas.ea.util.Step.jsviewDataPreviewDialog.destroy();
        }

        // in with the new
        sas.ea.util.Step.jsviewDataPreviewDialog = new sap.ui.jsview( "sas.ea.view.DataPreviewDialog" );
        sas.ea.util.Step.dlgDataPreview.addContent( sas.ea.util.Step.jsviewDataPreviewDialog );

        // before we open it, let's make sure it has all the info it needs
        //sas.ea.util.Step.dlgDataPreview.projectID = sas.ea.util.JobResults.getProjectUID( uidUi );
        //sas.ea.util.Step.dlgDataPreview.jobID =  sas.ea.util.JobResults.getJobUID( uidUi );
        //sas.ea.util.Step.dlgDataPreview.stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );

	      //get ID from url and then search SEA.oDataSources
	      rs.DataService.getDataSources().resultHandler = function (result) {
		        if (result !== null) {
                SEA.oDataSources = $.parseJSON(result);
                var aCD = SEA.oDataSources.claimsData;
                var sId = sUrl.substr( sUrl.indexOf("filesets/")+9 );
                sId = sId.substr( 0, sId.indexOf("/") );
                for ( var x=0; x < aCD.length; ++x ) {
                    if ( sId === aCD[x].id ) {
                        console.log("Add MT call here - 2, input data: " + aCD[x].name + ", " + sData.substr(0, sData.indexOf(".")) );
	                      rs.auditDataView("", sData.substr(0, sData.indexOf("."))+".sas7bdat", aCD[x].name );
                        break;
                    }
                }
		        }
	      };

        sas.ea.util.Step.dlgDataPreview.open();

        // we'll do the first one for the user :-)
        sas.ea.util.Step.dlgDataPreview.refresh();
    }
};
