// (c) 2015, SAS Institute Inc.

/*eslint no-cond-assign:0*/  //this is used a BUNCH in this file...against style guidelines but legit
jQuery.sap.require("sas.hc.ui.commons.SplitButton");
jQuery.sap.require("sas.hc.m.FlexItemData");
jQuery.sap.require("sas.hc.ui.commons.Label");
jQuery.sap.require("sap.ui.commons.layout.VerticalLayout");
jQuery.sap.require("sap.ui.commons.MessageBox");                // this is required since there is no direct access to the box's icons like MessageBox.Icon.WARNING

jQuery.sap.declare("sas.ea.util.Step");
jQuery.sap.require("sas.ea.util.JobResults");
jQuery.sap.require("sas.ea.util.StepParmsDlg");
jQuery.sap.require("sas.ea.util.Overview");


/**
 * Contains helper functions for building the step panels for the Job/Step details page
 */

sas.ea.util.Step = {

    // START *********************************************************************
    // for step parms dialogs
    projectID: "",
    jobID: "",
    stepKEY: "",
    stepID: "",

    dlgStepParms: new sas.hc.m.Dialog({  modal:true, stretch: true,
        leftButton:new sas.hc.m.Button({
            text: oBundle.getText( "StepParmsDialog.Save.Button" ),
            enabled: true,
            press: function () {
                //if ( _dlgNewJob.validateJobDlg() ) {
                //    //debugger;
                //    _dlgNewJob.createHandler( oController, SEA.aRp[SEA.iCurr].oObjMgr, openItem, repositoryTabs.getSelectedIndex(), buildJobPage );

                // saspfj, save parms here
                sas.ea.util.Step.jsviewStepParmsDlgContent.save();
                // this code needs to be in the save() function, not here. Just in case dialog is in error and we aren't closing it.
                //      sas.ea.util.Step.dlgStepParms.close();

                // saspfj, ToDo,
                // for RA, have Lisa add the corresponding code
                // set step status to Pending & enable the Run button
                /*
                 sas.ea.util.Step.projectID = projectID;
                 sas.ea.util.Step.jobID = jobID;
                 sas.ea.util.Step.stepKEY = stepKEY;
                 sas.ea.util.Step.stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );
                 */

                // notify owner if they are not the one updating this job
                if (SEA.oActJob.owner !== SEA.userid) {
                    var projectID = sas.ea.util.JobResults.getProjectUID(sas.ea.util.Step.dlgStepParms.uidUi);
                    var jobID = sas.ea.util.JobResults.getJobUID(sas.ea.util.Step.dlgStepParms.uidUi);
                    var iRepoIndex = parseInt(projectID.substr(1, 2), 10) - 1;     // saspfj, put this & others into lib
                    // let the owner know that an override happened
                    var jobName = sas.ea.util.Misc.getJobName(SEA.aRp[iRepoIndex].oJobs.jobs, jobID);
                    rs.sendUserMessage(SEA.oActJob.owner, "P" + oBundle.getText("User.ParmsOver") + "\n\nProject: " + SEA.aRp[iRepoIndex].oRepoMeta.name + "\nJob: " + jobName);
                }
            }
        }),
        rightButton:new sas.hc.m.Button({
            text: oBundle.getText("Cancel.Button.txt"),
            press: function () {
                sas.ea.util.Step.dlgStepParms.close();
            }
        })
    }),

    jsviewStepParmsDlgContent: null,
    // END *********************************************************************


    // START *********************************************************************
    //    dlgDataPreview: new sas.hc.m.Dialog({ contentWidth:"90%", modal:true,
    dlgDataPreview: new sas.hc.m.Dialog({ modal:true, stretch:true,
    //dlgDataPreview: new sas.hc.m.Dialog({ contentWidth:SEA.dlg.getMaxWidth()+"px", contentHeight:SEA.dlg.getMaxHeight()+"px", modal:true,
        rightButton:new sas.hc.m.Button({
            text: oBundle.getText("Close.Button.txt"),
            press: function () {
                sas.ea.util.Step.dlgDataPreview.close();
            }
        })
    }),

    jsviewDataPreviewDialog: null,

    showDataPreviewDialog: function ( uidUi, stepKEY, sData, sLabel, sUrl ) {
        //debugger;
        //alert("DataPreviewDialog\n\nfor\n\n" + sLabel + "\n\n" + sUrl)

        sas.ea.util.Step.dlgDataPreview.setTitle(oBundle.getText("DataPreviewDialog.title") + " " + sLabel);
        sas.ea.util.Step.dlgDataPreview.sDataset = sData;
        sas.ea.util.Step.dlgDataPreview.bGeorge = false;

        // out with the old
        sas.ea.util.Step.dlgDataPreview.destroyContent();

        // shouldn't have to, but we do anyway
        if (sas.ea.util.Step.jsviewDataPreviewDialog !== null) {
            sas.ea.util.Step.jsviewDataPreviewDialog.destroy();
        }

        // in with the new
        sas.ea.util.Step.jsviewDataPreviewDialog = new sap.ui.jsview("sas.ea.view.DataPreviewDialog");
        sas.ea.util.Step.dlgDataPreview.addContent(sas.ea.util.Step.jsviewDataPreviewDialog);

        // before we open it, let's make sure it has all the info it needs
        sas.ea.util.Step.dlgDataPreview.projectID = sas.ea.util.JobResults.getProjectUID(uidUi);

        // if we're an EC step, get the shared EC jobID, else get the regular jobID
        if ( stepKEY === SC.STEP_KEY_EC ) {
            sas.ea.util.Step.dlgDataPreview.jobID = sas.ea.util.JobResults.getJobUIDEC(uidUi);
        } else {
            sas.ea.util.Step.dlgDataPreview.jobID = sas.ea.util.JobResults.getJobUID(uidUi);
        }

        sas.ea.util.Step.dlgDataPreview.stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );
	      console.log("Add MT call here - 1, dataset dlg: " + SEA.aRp[SEA.iCurrentTab].oRepoMeta.id + ", " + sData);
	      rs.auditDataView( SEA.aRp[SEA.iCurrentTab].oRepoMeta.id, sData+".sas7bdat", null );
        sas.ea.util.Step.dlgDataPreview.open();

        // we'll do the first one for the user :-)
        sas.ea.util.Step.dlgDataPreview.refresh();
    },
    // END *********************************************************************


    // RA Reports:  0-Episode  1-Patient  2-Services  3-Data Exploration  4-Bundled Payment  5-Provider  6-Budget  7-Bundled Payment with RA
    // START *********************************************************************
    dlgLoadLASRoptions: new sas.hc.m.Dialog({ modal:true,
        leftButton:new sas.hc.m.Button({
            text: oBundle.getText("Create.Button.txt"),
            press: function () {

                // don't allow any other steps to run while this is running
                sas.ea.util.Step.disableRunButtons( sas.ea.util.Step.dlgLoadLASRoptions.uidUi, SC.STEP_KEY_LV );

                // shortcut var for use below
                var aRpts = sas.ea.util.Step.dlgLoadLASRoptions.jsonParms.reports;
                // saspfj, 3.2, change to more data-driven code
                for ( var x=0; x < aRpts.length; ++x ) {
                    if ( !aRpts[x].bAvail ) {
                        // skip over unavailable reports & be sure not to include them (if they're not auto)
                        if ( !aRpts[x].auto ) {
                            aRpts[x].included = false;
                        }
                        continue;
                    }
                    aRpts[x].included = sap.ui.getCore().byId("chkLL"+aRpts[x].reportID).getSelected();
                }

                var cloneVAparms = JSON.parse( JSON.stringify( sas.ea.util.Step.dlgLoadLASRoptions.jsonParms ) );
                // now get rid of the bAvail, since MT doesn't need it
                for ( var y=0; y < cloneVAparms.reports.length; ++y ) {
                    delete cloneVAparms.reports[y].bAvail;
                }
                //var sJSON = JSON.stringify( sas.ea.util.Step.dlgLoadLASRoptions.jsonParms );
                var sJSON = JSON.stringify( cloneVAparms );
                //debugger;
                SEA.log( "parms", "SET:" + sas.ea.util.Step.dlgLoadLASRoptions.projectID + "," + sas.ea.util.Step.dlgLoadLASRoptions.jobID + "," + sas.ea.util.Step.dlgLoadLASRoptions.stepID + "," + sJSON );
                rs.ProjectService.setParameters( sas.ea.util.Step.dlgLoadLASRoptions.projectID, sas.ea.util.Step.dlgLoadLASRoptions.jobID, sas.ea.util.Step.dlgLoadLASRoptions.stepID, sJSON ).resultHandler = function(out) {
                    // out is null, so nothing to do
                    //debugger;
                    delete cloneVAparms;

                    //debugger;
                    SEA.log( "VA", "createVAreports" );
                    sas.ea.util.Step.dlgLoadLASRoptions.iTaskCnt = 0;      // getting ready, reset to zero
                    sas.ea.util.Step.dlgLoadLASRoptions.iTaskStarts = 0;   // getting ready, reset to zero
                    sas.ea.util.Step.dlgLoadLASRoptions.iTasksDone = 0;    // getting ready, reset to zero

                    var request = {
                        "projectID" : sas.ea.util.Step.dlgLoadLASRoptions.projectID,
                        "jobID"     : sas.ea.util.Step.dlgLoadLASRoptions.jobID
                    };
                    SEA.log( "SAS", "batchRequest-runETL called with: " + JSON.stringify(request) );
                    SEA.log( "VAinfo", "batchRequest() called" );
                    rs.ExecutionService.batchRequest( JSON.stringify(request), SC.PROD_VAUPLOAD, SC.METHOD_ETL, SC.PRIORITY_NORMAL).resultHandler = function(aCC) {
                        //debugger;
                        SEA.log( "VAinfo", "batchRequest() claimChecks: " + aCC.length );

                        // saspfj, determine if we need to do anything with these
                        if (aCC !== null) {
                            for (var x = 0; x < aCC.length; ++x) {
                                //debugger; // saspfj, figure out what VA claim checks look like
                                SEA.log( "SAS", "claimCheck[" + x + "] ID/Name/Data: " + aCC[x].JobId + "/" + aCC[x].JobName + "/" + aCC[x].ReturnData);
                            }
                        }
                    };

                    sas.ea.util.Step.dlgLoadLASRoptions.close();
                };
            }
        }),
        rightButton:new sas.hc.m.Button({
            text: oBundle.getText("Cancel.Button.txt"),
            press: function () {
                sas.ea.util.Step.dlgLoadLASRoptions.close();
                sap.ui.getCore().byId( "FLOW" + sas.ea.util.Step.dlgLoadLASRoptions.uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( true ); // just kidding
            }
        })
    }),

    jsviewLoadLASRoptionsDialog: null,

    showLoadLASRoptionsDialog: function ( uidUi ) {

        sas.ea.util.Step.dlgLoadLASRoptions.setTitle(oBundle.getText("LoadLasrDialog.title"));
        sas.ea.util.Step.dlgLoadLASRoptions.uidUi = uidUi;

        // still using this guy, since it will be fine during the life of the dialog (UI active life that is)
        sas.ea.util.Step.dlgLoadLASRoptions.jsonParms = sas.ea.util.JobResults.getVAparmsForUID( uidUi );

        // out with the old
        sas.ea.util.Step.dlgLoadLASRoptions.destroyContent();

        // shouldn't have to, but we do anyway
        if ( sas.ea.util.Step.jsviewLoadLASRoptionsDialog !== null ) {
            sas.ea.util.Step.jsviewLoadLASRoptionsDialog.destroy();
        }

        // get the project & job IDs, so we can submit the batchRequest later
        sas.ea.util.Step.dlgLoadLASRoptions.uidUi = uidUi;
        sas.ea.util.Step.dlgLoadLASRoptions.projectID = sas.ea.util.JobResults.getProjectUID( uidUi );
        sas.ea.util.Step.dlgLoadLASRoptions.jobID = sas.ea.util.JobResults.getJobUID( uidUi );
        sas.ea.util.Step.dlgLoadLASRoptions.stepID = sas.ea.util.JobResults.getStepUID( uidUi, SC.STEP_KEY_VA );

        // shortcut var for use below
        var aRpts = sas.ea.util.Step.dlgLoadLASRoptions.jsonParms.reports;

        // in with the new
        sas.ea.util.Step.jsviewLoadLASRoptionsDialog = new sap.ui.jsview( "sas.ea.view.LoadLASRoptionsDialog" );
        //debugger;
        sas.ea.util.Step.dlgLoadLASRoptions.addContent( sas.ea.util.Step.jsviewLoadLASRoptionsDialog );
        sas.ea.util.Step.dlgLoadLASRoptions.open();

        // Reports:  0-Episode  1-Patient  2-Provider  3-Services  4-Bundled Payment  5-Budget  6-Bundled Payment with RA
        // episode not exposed to UI [0]
        // patient not exposed to UI [1]

        for ( var x=0; x < aRpts.length; ++x ) {
            if ( !aRpts[x].bAvail ) {
                // skip over any unavailable reports
                continue;
            }
            sap.ui.getCore().byId("chkLL"+aRpts[x].reportID).setEnabled( aRpts[x].bAvail );
            sap.ui.getCore().byId("chkLL"+aRpts[x].reportID).setSelected( aRpts[x].included );
        }
    },
    // END *********************************************************************

    // START *********************************************************************
    dlgExport: new sas.hc.m.Dialog({
        contentWidth: "30%",
        modal:true,
        leftButton:new sas.hc.m.Button("exportBtn", {
            text: oBundle.getText("Export.Button.txt"),
            enabled: true,
            press: function () {

                // to get around S, we do this check here
                var sTxt1 = sap.ui.getCore().byId('exportAdd1').getValue().trim();
                var sTxt2 = sap.ui.getCore().byId('exportAdd2').getValue().trim();
                // if either is empty, then just disable Export button (no need to display while they are entering)
                // NOTE: replicated code here and in step.js for dlgExport definition to get around S1207950 bug
                if ( (sTxt1 === "") || (sTxt2 === "")) {
                    sap.ui.getCore().byId('exportErrorMsg').setVisible( false );
                    //sap.ui.getCore().byId('exportBtn').setEnabled( false );
                    return;
                } else {
                    var bMatch = sTxt1 === sTxt2;
                    sap.ui.getCore().byId('exportErrorMsg').setVisible( !bMatch );
                    //sap.ui.getCore().byId('exportBtn').setEnabled( bMatch );
                    if ( !bMatch ) {
                        return;
                    }
                }

                var request = {
                    "projectID" : sas.ea.util.Step.dlgExport.projectID,
                    "jobID"     : sas.ea.util.Step.dlgExport.jobID,
                    "email"     : sap.ui.getCore().byId('exportAdd1').getValue().trim(),
                    "include"   : sap.ui.getCore().byId('exportChk').getSelected(),
                    "userID"    : SEA.userid,
                    "isPQS"     : sas.ea.util.Step.dlgExport.jobType === SC.JOB_TYPE_SUBSET
                };

                SEA.log( "SAS", "batchRequest-METHOD_EXPORT called with: " + JSON.stringify(request) );
                SEA.log( "Export", "Export REQUESTED" );
                rs.ExecutionService.batchRequest( JSON.stringify(request), SC.PROD_SEA, SC.METHOD_EXPORT, SC.PRIORITY_NORMAL).resultHandler = function(aCC) {
                    //debugger;
                    // nothing to do at this time with claimchecks
                    //if (aCC !== null) {
                    //    for (var x = 0; x < aCC.length; ++x) {
                    //        SEA.log( "SAS", "claimCheck[" + x + "] ID/Name/Data: " + aCC[x].JobId + "/" + aCC[x].JobName + "/" + aCC[x].ReturnData);
                    //    }
                    //}

                    // now that it's going, let's keep our in-memory status up-to-date
                    SEA.log( "Export", "Export CLAIM CHECKS" );
                    rs.ProjectService.getExportInfo(sas.ea.util.Step.dlgExport.projectID).resultHandler = function (expResults) {
                        SEA.log( "Export", "FIRST STATUS check!" );
                        sas.ea.util.MidTierMessage.processExportInfoResults(expResults);
                    };
                };

                sas.ea.util.Step.dlgExport.close();

                SEA.tmrStep.startStep( sap.ui.getCore().byId("btnExport" + sas.ea.util.Step.dlgExport.jobID), 0, oBundle.getText("Exporting.Button.txt") + " - ");
            }
        }),
        rightButton:new sas.hc.m.Button({
            text: oBundle.getText("Cancel.Button.txt"),
            press: function () {
                sas.ea.util.Step.dlgExport.close();
            }
        })
    }),

    //history
    histDialog: new sas.hc.m.Dialog({ modal:true,
        width: "100%",
        leftButton: new sas.hc.m.Button({
            text: "Close",
            enabled: true,
            press:function() {
                sas.ea.util.Step.histDialog.close();
            }
        })
    }),

    jsviewExportDialog: null,

    showExportDialog: function ( projectID, jobID, jobType ) {

        // get the job name form the ID
        sas.ea.util.Step.dlgExport.setTitle( oBundle.getText("ExportDialog.title") + sas.ea.util.JobResults.getJobObj(jobID).name );

        // out with the old
        sas.ea.util.Step.dlgExport.destroyContent();

        // shouldn't have to, but we do anyway
        if ( sas.ea.util.Step.jsviewExportDialog !== null ) {
            sas.ea.util.Step.jsviewExportDialog.destroy();
        }

        // get the project & job IDs, so we can submit the batchRequest later
        sas.ea.util.Step.dlgExport.projectID = projectID;
        sas.ea.util.Step.dlgExport.jobID = jobID;
        sas.ea.util.Step.dlgExport.jobType = jobType;

        // in with the new
        sas.ea.util.Step.jsviewExportDialog = new sap.ui.jsview( "sas.ea.view.ExportDialog" );
        //debugger;
        sas.ea.util.Step.dlgExport.addContent( sas.ea.util.Step.jsviewExportDialog );
        sas.ea.util.Step.dlgExport.open();

        sap.ui.getCore().byId('exportAdd1').setValue( SEA.email );
        sap.ui.getCore().byId('exportAdd2').setValue( SEA.email );

        // they will be the same at this point ;-)
        sap.ui.getCore().byId('exportErrorMsg').setVisible( false );

        // only enable if e-mail is non-blank
        sap.ui.getCore().byId('exportBtn').setEnabled( SEA.email !== "" );

        // if this is a Subset job, select checkbox and hide it
        if ( jobType === SC.JOB_TYPE_SUBSET ) {
            sap.ui.getCore().byId('exportChk').setSelected( true );
            sap.ui.getCore().byId('exportChk').setVisible( false );
        }
    },
    showHistoryDialog: function ( projectID, jobID ) {
        sas.ea.util.Step.histDialog.setTitle(oBundle.getText("JobExecution.History.title.txt"));
        sas.ea.util.Step.histDialog.destroyContent();

        SEA.histModel = new sap.ui.model.json.JSONModel();

        rs.ProjectService.getJobHistory(projectID,jobID).resultHandler = function( result ) {
            //var ctrl = sap.ui.getCore().byId("FLOW" + SEA.selectedJob + "HISTORY");
            if (result) {
                SEA.histModel.setData($.parseJSON(result), true);
                var dialogView = new sap.ui.jsview("sas.ea.view.JobExecutionHistoryDialog" );
                sas.ea.util.Step.histDialog.addContent(dialogView);
                sas.ea.util.Step.histDialog.open();
            }
        };
    },
    // END *********************************************************************

    // called by toggle below as well as programmatically to show hide certain
    // step panels
    expcolShowPanel: function ( bShow, uidUi, stepKEY ) {
        var sId = "FLOW" + uidUi + "STEPPANEL_" + stepKEY;

        // only procedd if the ctrl is there
        if ( sap.ui.getCore().byId( sId+"-pnlExpCol" ) ) {
            var bV = sap.ui.getCore().byId(sId + "-pnlExpCol").getVisible();

            // only change state if it's not in the one we want
            if (bV !== bShow) {
                sap.ui.getCore().byId(sId + "-pnlExpCol").setVisible(bShow);
                if (bShow) {
                    $("#" + sId + "-spnExpCol").html("<img src='html/resources/sas/ea/images/DownTriangle.png' " +
                        "alt='" + oBundle.getText("StepPanels.Collapse") + "' " +
                        "title='" + oBundle.getText("StepPanels.Collapse") + "'/>"
                    );
                } else {
                    $("#" + sId + "-spnExpCol").html("<img src='html/resources/sas/ea/images/RightTriangle.png' " +
                        "alt='" + oBundle.getText("StepPanels.Expand") + "' " +
                        "title='" + oBundle.getText("StepPanels.Expand") + "'/>"
                    );
                }
            }
        }
    },

    // called by clicking on the triangle, so this just toggles the current state
    expcolPanel: function ( uidUi, stepKEY ) {
        var sId = "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-pnlExpCol" ;
        sas.ea.util.Step.expcolShowPanel( !sap.ui.getCore().byId( sId ).getVisible(), uidUi, stepKEY );
    },

    createStepPanelGridData:function() {
        return new sap.ui.layout.GridData({ span:"L12 M12 S12" });
    },

    createStepPanelExpColBtn: function ( sId, uidUi, stepKEY ) {

        var sHtml =
            //"<div><span id='" + sId+"-spnExpCol' style='cursor:hand; visibility:hidden;' " +
            "<div><span id='" + sId+"-spnExpCol' style='cursor:hand;' " +
            "onclick='sas.ea.util.Step.expcolPanel(\"" + uidUi + "\", \"" + stepKEY + "\");'>" +
            "<img src='html/resources/sas/ea/images/DownTriangle.png' " +
            "alt='" + oBundle.getText("StepPanels.Collapse") + "' " +
            "title='" + oBundle.getText("StepPanels.Collapse") + "'/>" +
            "</span><br/></div>";

        return new sap.ui.core.HTML({ content:sHtml });
    },

    createStepPanelImage: function ( sId, stepKEY, eIcon ) {
        //return new sas.hc.m.Button({ icon:eIcon });
        SEA.log( "UID", sId+"-image" );
        var sSrc = "html/resources/sas/ea/images/";
        switch ( stepKEY ) {
            case SC.STEP_KEY_EC: sSrc += "EC.png";     break;
            case SC.STEP_KEY_LV: sSrc += "LV.png";     break;
            case SC.STEP_KEY_PS: sSrc += "PS.png";     break;
            case SC.STEP_KEY_PA: sSrc += "PA.png";     break;
            case SC.STEP_KEY_RA: sSrc += "RA.png";     break;
            case SC.STEP_KEY_VA: sSrc += "VA.png";     break;
        }
        return new sas.hc.m.Image({
            id: sId + '-image',
            src: sSrc
        });
    },

    createStepPanelTitle: function ( sId, stepKEY, sRes ) {
        SEA.log( "UID", sId+"-label1" );
        return new sap.m.Label({id: sId + '-label1', text:oBundle.getText(sRes)});
    },

    // test code for inserting image
    //createTestThingie: function ( sId, stepKEy ) {
    //
    //    //return new sap.ui.core.Icon({
    //    //    id: sId + '-thingie',
    //    //    src: sas.icons.HC.IMAGE,
    //    //    height: "1.5em",
    //    //    size: "7em"
    //    //});
    //
    //    return new sap.ui.core.Icon({
    //        id: sId + '-thingie',
    //        src: sas.icons.HC.IMAGE,
    //        height: "1.5em",
    //        size: "1.5em"
    //    }).addStyleClass("YoVernIsClassy");
    //},
    // if above is used, following CSS should be used in index.jsp
    //.YoVernIsClassy {
    //    background-color: yellow;
    //    padding-left: 6px;
    //    padding-right: 6px;
    //}


createStepPanelStatusIcon: function ( sId, stepKEY, sRes ) {
        SEA.log( "UID", sId+"-statusIcon" );
        return new sas.hc.m.Image({id: sId + '-statusIcon', text:oBundle.getText(sRes)});
    },

    createStepPanelStatus: function ( sId, stepKEY, sRes ) {
        SEA.log( "UID", sId+"-status" );
        return new sas.hc.m.Label({id: sId + '-status', text:oBundle.getText(sRes)});
    },

    createStepPanelTimer: function ( sId, stepKEY ) {
        SEA.log( "UID", sId+"-timer" );
        return new sap.ui.core.HTML({
            content:"<span id="+"'"+sId+"-timer' style='font-size:small; font-variant:small-caps;'></span>"
            //content:"<span style='font-size:small; font-variant:small-caps;'></span>"
        });
    },

    createStepPanelSpacer: function ( sId, stepKEY ) {
        SEA.log( "UID", sId+"-toolbarSpacer1" );
        return new sap.m.ToolbarSpacer({ id:sId+'-toolbarSpacer1' });
    },

    //createStepPanelExportBtn: function ( sId, stepKEY, uidUi ) {
    //    SEA.log( "UID", sId+"-btnExp" );
    //    return new sas.hc.m.Button({
    //        id: sId+'-btnExp', icon:sas.icons.HC.EXPORT, enabled:false,
    //        press: function () { sas.ea.util.Step.stepExportHandler(uidUi, stepKEY); }
    //    });
    //},

    createStepPanelRunBtn: function ( sId, stepKEY, uidUi, sRes ) {
        SEA.log( "UID", sId+"-btnRun" );
        return new sas.hc.m.Button({
            //icon: sas.icons.HC.RUNSELECTEDNODES,
            id: sId+'-btnRun', text:oBundle.getText(sRes), enabled:false,
            press: function () {
                sas.ea.util.Step.stepRunHandler(uidUi, stepKEY);
            }
        });
    },

    createStepPanelSplitRunBtn: function ( sId, stepKEY, uidUi, sRes, bPQS ) {
        SEA.log( "UID", sId + "-btnRun" );

        var oButton = new sas.hc.ui.commons.SplitButton({
            id: sId + '-btnRun',
            text: oBundle.getText("Run.Button.txt"),
            tooltip: oBundle.getText("Run.Button.tip"),
            // press handlers are done below
            layoutData: new sas.hc.m.FlexItemData({growFactor: 1})
        });
        oButton.setMenu(makeMenu(sId));
        oButton.setEnabled(true);
        oButton.setVisible(true);

        function makeMenu(sId) {

            return new sas.hc.ui.commons.Menu({
                id: sId + '-menu',
                items: [
                    new sas.hc.ui.commons.MenuItem({
                        //icon: sas.icons.HC.RUNSELECTEDNODES,
                        text: oBundle.getText("Run.Button.txt"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            sas.ea.util.Step.stepRunHandler(uidUi, stepKEY);
                        }
                    }),
                    new sas.hc.ui.commons.MenuItem({
                        id: sId + '-btnRunAll',
                        enabled: !bPQS,
                        text: oBundle.getText("JobStepDetail.RunAll.btn"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            sas.ea.util.Step.stepRunAllHandler(uidUi, stepKEY);
                        }
                    })
                    // saspfj, 3.2, allow user to schedule run @ night (down time)
                    //new sas.hc.ui.commons.MenuItem({
                    //    text: "3.2 Run All Later...",
                    //    select: function(oEvent){alertEvent(oEvent, true)}
                    //})
                ]
            });
        }
        return oButton;
    },

    createJobSplitBtn: function ( newAnalysisHandler, newSubsetHandler ) {

        var oButton = new sas.hc.ui.commons.SplitButton({
            text: oBundle.getText("REPO.NewAnalysisJob"),
            // press handlers are done below
            layoutData: new sas.hc.m.FlexItemData({growFactor: 1})
        });
        oButton.setMenu(makeJobMenu());
        oButton.setEnabled(true);
        oButton.setVisible(true);

        function makeJobMenu() {

            return new sas.hc.ui.commons.Menu({
                //id: sId + '-menu',
                items: [
                    new sas.hc.ui.commons.MenuItem({
                        text: oBundle.getText("REPO.NewAnalysisJob"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            newAnalysisHandler( oButton );
                        }
                    }),
                    new sas.hc.ui.commons.MenuItem({
                        enabled: SEA.lic.EA_PQS,
                        text: oBundle.getText("REPO.NewPatientSubset"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            newSubsetHandler( oButton );
                        }
                    })
                ]
            });
        }
        return oButton;
    },

    createRepoSplitBtn: function ( reuseRepoHandler, clearRepoHandler ) {

        var oButton = new sas.hc.ui.commons.SplitButton({
            text: oBundle.getText("REPO.ReuseRepo"),
            // press handlers are done below
            layoutData: new sas.hc.m.FlexItemData({growFactor: 1})
        });
        //var oButton = new sas.hc.ui.commons.SplitButton({
        //    text: oBundle.getText("REPO.LockRepo"),
        //    // press handlers are done below
        //    layoutData: new sas.hc.m.FlexItemData({growFactor: 1})
        //});

        oButton.setMenu(makeJobMenu());
        oButton.setEnabled(true);
        oButton.setVisible(true);

        function makeJobMenu() {

            return new sas.hc.ui.commons.Menu({
                items: [
                    //new sas.hc.ui.commons.MenuItem({
                    //    text: oBundle.getText("REPO.LockRepo"),
                    //    select: function () {
                    //        var uidUi = sas.ea.util.JobResults.getUiUID(SEA.aRp[SEA.iCurrentTab].oJobs.jobs[0].jobID);
                    //        sas.ea.util.Step.stepLockHandler(uidUi, SC.STEP_KEY_EC);
                    //    }
                    //}),
                    new sas.hc.ui.commons.MenuItem({
                        text: oBundle.getText("REPO.ReuseRepo"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            reuseRepoHandler();
                        }
                    }),
                    new sas.hc.ui.commons.MenuItem({
                        text: oBundle.getText("REPO.ClearRepo"),
                        //select: function(oEvent){alertEvent(oEvent, true)}
                        select: function () {
                            clearRepoHandler();
                        }
                    })
                ]
            });
        }
        return oButton;
    },

    createStepPanelParmsBtn: function ( sId, stepKEY, uidUi ) {
        SEA.log( "UID", sId+"-btnParms" );
        return new sas.hc.m.Button({
            id: sId+'-btnParms', icon:sas.icons.HC.OPTIONS, // saspfj, afterUIstudy text:oBundle.getText("Options.Button.txt"),
            press: function () {
                sas.ea.util.Step.stepParmsHandler(uidUi, stepKEY);
            }
        });
    },

    createStepPanelExpColPanel: function ( sId, stepKEY ) {
        var vlPanel = null;

        switch ( stepKEY ) {
            case SC.STEP_KEY_EC:
            case SC.STEP_KEY_LV:
            case SC.STEP_KEY_PS:
            case SC.STEP_KEY_PA:
            case SC.STEP_KEY_RA:
                vlPanel = new sap.ui.layout.VerticalLayout( sId+"-pnlExpCol", {
                    width: "100%",
                    content: [
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsR",      // Reports
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        }),
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsD",      // Data
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        }),
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsO",      // Other
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        })
                    ]
                });
            break;

            case SC.STEP_KEY_VA:
                vlPanel = new sap.ui.layout.VerticalLayout( sId+"-pnlExpCol", {
                    width: "100%",
                    content: [
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsA",      // reports available to be created & loaded
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        }),
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsV",      // reports loaded into LASR
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        }),
                        new sas.hc.ui.layout.Grid({
                            id: sId + "OutsO",      // Other
                            hSpacing: 1,
                            vSpacing: 1,
                            content: []
                        })
                    ]
                });
            break;
        }

        return vlPanel;
    },

    createStepPanelToolbar: function ( sId, stepKEY, uidUi, sRes, bPQS ) {

        var tlbPanel = null;

        switch ( stepKEY ) {
            case SC.STEP_KEY_EC:
                tlbPanel = new sap.m.Toolbar({
                    id: sId + '-toolbar1',
                    content: [
                        sas.ea.util.Step.createStepPanelExpColBtn( sId, uidUi, stepKEY ),
                        sas.ea.util.Step.createStepPanelImage( sId, stepKEY, sas.icons.HC.SOURCEDATABASE ),
                        sas.ea.util.Step.createStepPanelTitle( sId, stepKEY, sRes ),
                        sas.ea.util.Step.createStepPanelStatusIcon( sId, stepKEY, "STEP.STATUS.ICON.LOCKED" ),
                        sas.ea.util.Step.createStepPanelStatus( sId, stepKEY, "STEP.STATUS.PENDING" ),
                        sas.ea.util.Step.createStepPanelTimer( sId, stepKEY ),
                        // saspfj, ToDo, GOOFLA,  this is how we'll need to redo our images to icons
                        // sas.ea.util.Step.createTestThingie( sId, stepKEY ),
                        sas.ea.util.Step.createStepPanelSpacer( sId, stepKEY ),
                        new sas.hc.m.Button({
                            id: sId + '-chkLock', text: oBundle.getText("StepPanels.LockBtn"),
                            press: function () {
                                sas.ea.util.Step.stepLockHandler(uidUi, stepKEY);
                            }
                        }),
                        //sas.ea.util.Step.createStepPanelExportBtn( sId, stepKEY, uidUi ),
                        sas.ea.util.Step.createStepPanelRunBtn( sId, stepKEY, uidUi, "Run.Button.txt" )//,
                        // saspfj, ToDo, VERN
                        //sas.ea.util.Step.createStepPanelParmsBtn( sId, stepKEY, uidUi )
                    ]
                });
            break;

            case SC.STEP_KEY_LV:
            case SC.STEP_KEY_PS:
            case SC.STEP_KEY_PA:
            case SC.STEP_KEY_RA:
                // the only difference between these 4 are the icon used so, we determine that here
                var oIcon=null;
                switch ( stepKEY ) {
                    case SC.STEP_KEY_LV: oIcon = sas.icons.HC.LAYERS;               break;
                    case SC.STEP_KEY_PS: oIcon = sas.icons.HC.USERDEFINEDTEMPLATE;  break;
                    case SC.STEP_KEY_PA: oIcon = sas.icons.HC.MEDICALPROVIDER;      break;
                    case SC.STEP_KEY_RA: oIcon = sas.icons.HC.TREND;                break;
                }

                tlbPanel = new sap.m.Toolbar({
                    id: sId + '-toolbar1',
                    content: [
                        sas.ea.util.Step.createStepPanelExpColBtn( sId, uidUi, stepKEY ),
                        sas.ea.util.Step.createStepPanelImage( sId, stepKEY, oIcon ),
                        sas.ea.util.Step.createStepPanelTitle( sId, stepKEY, sRes ),
                        sas.ea.util.Step.createStepPanelStatus( sId, stepKEY, "STEP.STATUS.PENDING" ),
                        sas.ea.util.Step.createStepPanelTimer( sId, stepKEY ),
                        sas.ea.util.Step.createStepPanelSpacer( sId, stepKEY ),
                        //sas.ea.util.Step.createStepPanelExportBtn( sId, stepKEY, uidUi ),
                        sas.ea.util.Step.createStepPanelSplitRunBtn( sId, stepKEY, uidUi, "Run.Button.txt", bPQS ),
                        sas.ea.util.Step.createStepPanelParmsBtn( sId, stepKEY, uidUi )
                    ]
                });
            break;

            case SC.STEP_KEY_VA:
                tlbPanel = new sap.m.Toolbar({
                    id: sId + '-toolbar1',
                    content: [
                        sas.ea.util.Step.createStepPanelExpColBtn( sId, uidUi, stepKEY ),
                        sas.ea.util.Step.createStepPanelImage( sId, stepKEY, sas.icons.HC.SASREPORT2G ),
                        sas.ea.util.Step.createStepPanelTitle( sId, stepKEY, sRes ),
                        sas.ea.util.Step.createStepPanelStatus( sId, stepKEY, "" ),
                        sas.ea.util.Step.createStepPanelTimer( sId, stepKEY ),
                        sas.ea.util.Step.createStepPanelSpacer( sId, stepKEY ),
                        //sas.ea.util.Step.createStepPanelExportBtn( sId, stepKEY, uidUi ),
                        sas.ea.util.Step.createStepPanelRunBtn( sId, stepKEY, uidUi, "CreateReports.Button.txt" )
                    ]
                });
            break;
        }

        return tlbPanel;
    },

    createStepPanel: function ( uidUi, stepKEY, sRes, bPQS ) {

        var sId = "FLOW" + uidUi + "STEPPANEL_" + stepKEY;

        return new sas.hc.m.Panel({
            id: sId,
            layoutData: sas.ea.util.Step.createStepPanelGridData(),
            headerToolbar: sas.ea.util.Step.createStepPanelToolbar(sId, stepKEY, uidUi, sRes, bPQS),
            content: [sas.ea.util.Step.createStepPanelExpColPanel(sId, stepKEY)]
        });
    },

    stepExecutionAnimation: function ( jobID, stepKEY, bStart, eStatus ) {
        //debugger;
        SEA.log( "Animation", "Animation - " + (bStart?"START":"END") + ", step:" + stepKEY );

        var uidUi = sas.ea.util.JobResults.getUiUID( jobID );

        //var ctrlBtn = sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun" );
        var ctrlStatus = sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-status" );
        var ctrlNode = sap.ui.getCore().byId( "FLOW" + uidUi + "NODE" + stepKEY );
        var sTmrId = "#FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-timer";

        // saspfj, add check for NULL controls, if any assume UI is going away and just exit

        if ( bStart ) {

            if ( ctrlStatus ) {
                ctrlStatus.setText("Processing");
            }

            if ( ctrlNode ) {
                ctrlNode.setIcon("html/resources/sas/ea/images/" + stepKEY + "spin.png");
            }

            if ( sTmrId ) {
                $(sTmrId).show();
                SEA.tmrStep.startStep(sTmrId, null);
            }
        } else {

            if ( ctrlNode ) {
                var sColor = "grey";
                switch (eStatus) {
                    case SC.STEP_STATUS_ERROR:
                        sColor = "Error";
                        break;
                    case SC.STEP_STATUS_WARNING:
                        sColor = "Warning";
                        break;
                    case SC.STEP_STATUS_SUCCESS:
                        sColor = "Success";
                        break;
                }
                ctrlNode.setIcon("html/resources/sas/ea/images/" + stepKEY + sColor + ".png");
            }

            if ( sTmrId ) {
                SEA.tmrStep.endStep(sTmrId);
            }
        }

    },

    getLastStepInJob: function ( jobID ) {

        for (var i=0; i<SEA.aRp[SEA.iCurrentTab].oJobs.jobs.length; ++i) {
            if (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].jobID === jobID){
                // if the last step is VA, return the one before that since VA is separate
                if (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps[SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps.length-1].progID === SC.STEP_KEY_VA) {
                    return SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps[SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps.length-2].progID;
                } else {
                    return SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps[SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps.length-1].progID;
                }
            }
        }
    },

    verifyNoRunningJobs: function ( sRes, oFunc ) {
        //debugger;

        // get jobs from the mid tier, to determine if any users have jobs running in this repository
        SEA.log( "MTdata", "getJobs called:" + SEA.aRp[SEA.iCurrentTab].oRepoMeta.id);
        rs.ProjectService.getJobs( SEA.aRp[SEA.iCurrentTab].oRepoMeta.id ).resultHandler = function (result ) {
            //debugger;
            SEA.log( "MTdata", "getJobs returned:" + result );

            if ( result !== "" ) {
                var oJobs = $.parseJSON( result );
                var bRunningJobs = false;

                jobs:
                for ( var x=0; x < oJobs.jobs.length; ++x ) {
                    var aSteps = sas.ea.util.NewJobDlg.getStepsForJob(oJobs.jobs, oJobs.jobs[x].jobID );
                    for ( var z=0; z < aSteps.length; ++z ) {
                        if (oJobs.jobs[x].steps[z].status === SC.JOB_STATUS_PROCESSING) {
                            bRunningJobs = true;
                            break jobs;
                        }
                    }
                }

                if (bRunningJobs) {
                    SEA.log("!", "There are running jobs.");
                    sas.hc.m.MessageBox.error(oBundle.getText(sRes), oBundle.getText("JobsRunning.title"));
                } else {
                    oFunc();
                }
            } else {
                SEA.log("!", "Mid-tier did not return any data.");
            }
        };
    },

    verifyRepoOwner: function () {
        //debugger;

        // if we have no jobs, then we have a corrupt repo, so return true so user can get rid of it
        if ( SEA.aRp[SEA.iCurrentTab].oJobs.jobs.length === 0 ) {
            return true;
        }

        // if current user is the owner, then run passed function with provided parms
        if ( SEA.aRp[SEA.iCurrentTab].oJobs.jobs[0].owner === SEA.userid ){
            SEA.log( "!", "VERIFIED Repo - user:" + SEA.userid + ", owner:" + SEA.aRp[SEA.iCurrentTab].oJobs.jobs[0].owner );
            return true;
        } else {
            // if this user is an admin, then run passed function with provided parms
            if ( SEA.bAdmin ) {
                SEA.log( "!", "Admin OVERRIDE - user:" + SEA.userid + ", owner:" + SEA.aRp[SEA.iCurrentTab].oJobs.jobs[0].owner );
                return true;
            } else {
                SEA.log( "!", "NonOwner - user:" + SEA.userid + ", owner:" + SEA.aRp[SEA.iCurrentTab].oJobs.jobs[0].owner );
                return false;
            }
        }
    },

    verifyRepoOwnerAndRun: function ( sRes, sResM, oFunc ) {

        // if current user is the owner or an admin, then run passed function with provided parms
        if ( sas.ea.util.Step.verifyRepoOwner() ){
            oFunc();
        } else {
            // user isn't the owner nor an admin, just inform them they can't do what they wanted
            sas.hc.m.MessageBox.information( oBundle.getText(sRes), oBundle.getText( "VerifiedRepoOwner.title" ),
                [sas.hc.m.MessageBox.Action.OK], null
            );
        }
    },

    verifyJobOwner: function ( jobOwner ) {
        //debugger;

        // if current user is the owner, then run passed function with provided parms
        if ( jobOwner === SEA.userid ){
            SEA.log( "!", "VERIFIED Job - user:" + SEA.userid + ", owner:" + jobOwner );
            return true;
        } else {
            // if this user is an admin, then run passed function with provided parms
            if ( SEA.bAdmin ) {
                SEA.log( "!", "Admin OVERRIDE - user:" + SEA.userid + ", owner:" + jobOwner );
                return true;
            } else {
                SEA.log( "!", "NonOwner - user:" + SEA.userid + ", owner:" + jobOwner );
                return false;
            }
        }
    },

    verifyJobOwnerAndRun: function ( sRes, sResM, oFunc, uidUi, stepKEY ) {

        // if current user is the owner or an admin, then run passed function with provided parms
        if ( sas.ea.util.Step.verifyJobOwner( SEA.oActJob.owner ) ){
            oFunc( uidUi, stepKEY );
        } else {
            // user isn't the owner nor an admin, just inform them they can't do what they wanted
            sas.hc.m.MessageBox.information( oBundle.getText(sRes), oBundle.getText( "VerifiedOwner.title" ),
                [sas.hc.m.MessageBox.Action.OK], null
            );
        }
    },

    stepRunHandler: function ( uidUi, stepKEY ) {
        sas.ea.util.Step.verifyJobOwnerAndRun( "OverrideRun.msg", "User.RunOver", sas.ea.util.Step.stepRunHandlerDOIT, uidUi, stepKEY  );
    },

    stepRunAllHandler: function ( uidUi, stepKEY ) {
        sas.ea.util.Step.verifyJobOwnerAndRun( "OverrideRun.msg", "User.RunOver", sas.ea.util.Step.stepRunAllHandlerDOIT, uidUi, stepKEY  );
    },

    JobNameFromID: function ( jobID ) {

        var aJobs = SEA.aRp[SEA.iCurrentTab].oJobs.jobs;
        for ( var x=0; x < aJobs.length; ++x ) {
            if ( aJobs[x].jobID === jobID ) {
                return aJobs[x].name;
            }
        }

        // this should NEVER happen
        return jobID;
    },

    NameFromUserID: function ( userID ) {

        var aUsers = SEA.userInfo.users;
        for ( var x=0; x < aUsers.length; ++x ) {
            if ( aUsers[x].userid === userID ) {
                return aUsers[x].name;
            }
        }

        // this should NEVER happen
        return userID;
    },

    stepRunHandlerDOIT: function ( uidUi, stepKEY ) {
        //debugger;

        var projectID = sas.ea.util.JobResults.getProjectUID( uidUi );
        var jobID = sas.ea.util.JobResults.getJobUID( uidUi );
        var stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );

        // if export is currently running, then inform & prevent user from running
        if ( SEA.aRp[SEA.iCurrentTab].oExpInfo.status === SC.EXPORT_STATUS_PROCESSING ) {
            // now see if it's this job
            if ( jobID === SEA.aRp[SEA.iCurrentTab].oExpInfo.jobID ) {
                // yep, let the user know they have to wait until the export finishes
                sas.hc.m.MessageBox.information( oBundle.getText( "Export.Run.msg" ), oBundle.getText( "Export.InProgress.title" ),
                    [sas.hc.m.MessageBox.Action.OK], null
                );
                return;
            }
        }

        SEA.log ( "VA", "project:" + projectID + ", job:" + jobID + ", step:" + stepID );
        var ctrlBtn = sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun" );

        // only proceed if the ctrl is there
        if ( ctrlBtn ) {
            if ((ctrlBtn.getText() === oBundle.getText("Run.Button.txt")) || (ctrlBtn.getText() === oBundle.getText("CreateReports.Button.txt"))) {

                if (stepKEY === SC.STEP_KEY_VA) {
                    //debugger;
                    //SEA.aRp[SEA.iCurr].vaInfo.status = SC.REPO_STATUS_LOCKED;   // TEMP TESTING CODE

                    // always get the latest status of the VA info
                    rs.ProjectService.getVAInfo(projectID).resultHandler = function (result) {
                        if (result !== "") {
                            //debugger;
                            SEA.aRp[SEA.iCurrentTab].vaInfo = $.parseJSON(result);

                            SEA.log("VAinfo", "SEA.aRp[SEA.iCurrentTab].vaInfo.jobID: " + SEA.aRp[SEA.iCurrentTab].vaInfo.jobID);
                            SEA.log("VAinfo", "SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy: " + SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy);

                            switch (SEA.aRp[SEA.iCurrentTab].vaInfo.status) {
                                case SC.LASR_STATUS_EMPTY:
                                    SEA.log("VAinfo", "VA is EMPTY");
                                    sas.ea.util.Step.showLoadLASRoptionsDialog(uidUi);
                                    break;

                                case SC.LASR_STATUS_USED:
                                    // if we're updating this job, then no confirmation needed
                                    if (jobID === SEA.aRp[SEA.iCurrentTab].vaInfo.jobID) {
                                        sas.ea.util.Step.showLoadLASRoptionsDialog(uidUi);
                                    } else {
                                        //if (SEA.bFuture) {
                                        //    // BETA: better visual cupcake taking dialog
                                        //    var jsviewUseLasrDlgContent = null;
                                        //    var dlg = new sas.hc.m.Dialog({
                                        //        title: oBundle.getText("UseLasrDlg.title.txt"),
                                        //        contentWidth: "800px",
                                        //        modal: true,
                                        //        leftButton: new sas.hc.m.Button({
                                        //            text: oBundle.getText("Use.Button.txt"),
                                        //            press: function () {
                                        //                dlg.close();
                                        //                dlg.destroyContent();
                                        //                jsviewUseLasrDlgContent.destroy();
                                        //                sas.ea.util.Step.showLoadLASRoptionsDialog(uidUi);
                                        //            }
                                        //        }),
                                        //        rightButton: new sas.hc.m.Button({
                                        //            text: oBundle.getText("Cancel.Button.txt"),
                                        //            press: function () {
                                        //                dlg.close();
                                        //                dlg.destroyContent();
                                        //                jsviewUseLasrDlgContent.destroy();
                                        //            }
                                        //        })
                                        //    });
                                        //
                                        //    jsviewUseLasrDlgContent = new sap.ui.jsview("sas.ea.view.UseLasrDialog");
                                        //    dlg.addContent(jsviewUseLasrDlgContent);
                                        //    dlg.open();
                                        //} else {

                                        SEA.log("VAinfo", projectID + "-POPULATED with: " + sas.ea.util.Step.JobNameFromID(SEA.aRp[SEA.iCurrentTab].vaInfo.jobID) + ", by: " + sas.ea.util.Step.NameFromUserID(SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy));
                                        sas.hc.m.MessageBox.warning(
                                            oBundle.getText("VA.LASR.LOADED") + sas.ea.util.Step.JobNameFromID(SEA.aRp[SEA.iCurrentTab].vaInfo.jobID) + " " + oBundle.getText("VA.LASR.BY") + " " + sas.ea.util.Step.NameFromUserID(SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy) + oBundle.getText("VA.LASR.OVERWRITE"),
                                            oBundle.getText("VA.LASR.EXISTING.TITLE"),
                                            [SC.BTN_CONTINUE, sas.hc.m.MessageBox.Action.CANCEL], "",
                                            function (sResult) {
                                                if (sResult === SC.BTN_CONTINUE) {
                                                    sas.ea.util.Step.showLoadLASRoptionsDialog(uidUi);
                                                }
                                            }
                                        );
                                        //}
                                    }
                                    break;

                                case SC.LASR_STATUS_PROCESSING:
                                    // saspfj, 3.2, allow user to get e-mail when VA is ready

                                    SEA.log("VAinfo", projectID + "-PROCESSING with: " + sas.ea.util.Step.JobNameFromID(SEA.aRp[SEA.iCurrentTab].vaInfo.jobID) + ", by: " + sas.ea.util.Step.NameFromUserID(SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy));
                                    sas.hc.m.MessageBox.warning(
                                        oBundle.getText("VA.LASR.LOADING") + sas.ea.util.Step.JobNameFromID(SEA.aRp[SEA.iCurrentTab].vaInfo.jobID) + " " + oBundle.getText("VA.LASR.BY") + " " + sas.ea.util.Step.NameFromUserID(SEA.aRp[SEA.iCurrentTab].vaInfo.updatedBy) + oBundle.getText("VA.LASR.FINISHED"),
                                        oBundle.getText("VA.LASR.RUNNING.TITLE"),
                                        [sas.hc.m.MessageBox.Action.OK], ""
                                    );
                                    break;
                            }
                        } else {
                            // saspfj, we ought to display an error msg here and other places where we get VAinfo!!!
                            SEA.aRp[SEA.iCurrentTab].vaInfo = null;
                        }
                    };
                } else {
                    // disable this step from being run (until this current execution is finished) AND disable all downstream steps
                    // actually, we should disable ALL run buttons
                    sas.ea.util.Step.disableRunButtons(uidUi, stepKEY);

                    // if we're running EC, be sure the lock button is disabled
                    if (stepKEY === SC.STEP_KEY_EC) {
                        sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-chkLock").setEnabled(false);
                    }

                    // now clear out all artifacts from this step and any down-stream steps that need to be cleared
                    // I thought about doing this after the batchRequest, to save a bit of time...but thought there might be a
                    // chance (although very small), that the job would finish before the artifacts were cleared, which would be bad
                    sas.ea.util.JobResults.resetStepsUI(uidUi, stepKEY);

                    SEA.log("SAS", "Running single step Project/Job/Step/Key: " + projectID + "/" + jobID + "/" + stepID + "/" + stepKEY);
                    var s = JSON.stringify({"projectID": projectID, "jobID": jobID, "stepID": stepID});

                    var sClass = "";
                    var sMethod = "";
                    if (stepKEY === SC.STEP_KEY_EC) {
                        sClass = SC.PROD_EC;
                        sMethod = SC.METHOD_RUNEC;
                    } else {
                        sClass = SC.PROD_SEA;
                        sMethod = SC.METHOD_RUNSTEP;
                    }
                    rs.ExecutionService.batchRequest(s, sClass, sMethod, SC.PRIORITY_NORMAL).resultHandler = function (aCC) {
                        //debugger;

                        // saspfj, determine if we need to do anything with these
                        if (aCC !== null) {
                            for (var x = 0; x < aCC.length; ++x) {
                                SEA.log("SAS", "claimCheck[" + x + "] ID/Name/Data: " + aCC[x].JobId + "/" + aCC[x].JobName + "/" + aCC[x].ReturnData);
                            }
                        }
                    };
                    SEA.log("SAS", "batchRequest-runStep called with: " + s);
                }
            } else {
                // saspfj, 3.2, cancel code would go here

            }
        }
    },

    stepRunAllHandlerDOIT: function ( uidUi, stepKEY ) {
        //debugger;

        var projectID = sas.ea.util.JobResults.getProjectUID( uidUi );
        var jobID = sas.ea.util.JobResults.getJobUID( uidUi );
        var stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );

        sas.ea.util.Overview.addRunAllJob( jobID );

        sas.ea.util.Step.disableRunButtons( uidUi, SC.STEP_KEY_EC );

        //SEA.SLOG.resetTimer();
        SEA.log( "SAS", "RunAll Handler - START" );

        // clear out all artifacts here
        sas.ea.util.JobResults.clearAllPendingArtifacts( jobID );

        var s = JSON.stringify({"projectID": projectID, "jobID": jobID});
        rs.ExecutionService.batchRequest(s, SC.PROD_SEA, SC.METHOD_RUNJOB, SC.PRIORITY_NORMAL).resultHandler = function (aCC) {
            //debugger;

            // saspfj, determine if we need to do anything with these
            if (aCC !== null) {
                for (var x = 0; x < aCC.length; ++x) {
                    SEA.log("SAS", "claimCheck[" + x + "] ID/Name/Data: " + aCC[x].JobId + "/" + aCC[x].JobName + "/" + aCC[x].ReturnData);
                }
            }
        };
        SEA.log("SAS", "batchRequest-runJob called with: " + s);
    },

    //stepExportHandler: function ( uidUi, stepKEY ) {
    //    alert( "TBD - Export Step Artifacts Dialog" + "\n\nprojectID: " + sas.ea.util.JobResults.getProjectUID(uidUi) + "\njobID: " + sas.ea.util.JobResults.getJobUID(uidUi) + "\nstep: " + stepKEY );
    //},

    stepParmsHandler: function ( uidUi, stepKEY ) {
        sas.ea.util.Step.verifyJobOwnerAndRun( "OverrideParms.msg", "", sas.ea.util.Step.stepParmsHandlerDOIT, uidUi, stepKEY  );
    },

    stepParmsHandlerDOIT: function ( uidUi, stepKEY ) {
        //debugger;
        // alert( "TBD - Step ParametersPath Dialog" + "\n\nprojectID: " + sas.ea.util.JobResults.getProjectUID(uidUi) + "\njobID: " + sas.ea.util.JobResults.getJobUID(uidUi) + "\nstep: " + stepKEY );

        var jobID = sas.ea.util.JobResults.getJobUID( uidUi );

        // if export is currently running, then inform & prevent user from running
        if ( SEA.aRp[SEA.iCurrentTab].oExpInfo.status === SC.EXPORT_STATUS_PROCESSING ) {
            // now see if it's this job
            if ( jobID === SEA.aRp[SEA.iCurrentTab].oExpInfo.jobID ) {
                // yep, let the user know they have to wait until the export finishes
                sas.hc.m.MessageBox.information( oBundle.getText( "Export.Parms.msg" ), oBundle.getText( "Export.InProgress.title" ),
                    [sas.hc.m.MessageBox.Action.OK], null
                );
                return;
            }
        }

        sas.ea.util.Step.commonStepParmsDialogSetup( uidUi, sas.ea.util.JobResults.getProjectUID(uidUi), sas.ea.util.JobResults.getJobUID(uidUi), stepKEY );

        // remember these, we'll need them to clear out children steps if the user saves anything
        sas.ea.util.Step.dlgStepParms.uidUi = uidUi;
        sas.ea.util.Step.dlgStepParms.stepKEY = stepKEY;
        sas.ea.util.Step.dlgStepParms.open();
    },

    commonStepParmsDialogSetup: function( uidUi, projectID, jobID, stepKEY ) {

        var sTitle = "StepParmsDialog.title." + stepKEY;
        var sView = "sas.ea.view." + "StepParmsDialog" + stepKEY;

        // saspfj, should we put these off of the dlgStepParms?
        sas.ea.util.Step.projectID = projectID;
        sas.ea.util.Step.jobID = jobID;
        sas.ea.util.Step.stepKEY = stepKEY;
        sas.ea.util.Step.stepID = sas.ea.util.JobResults.getStepUID( uidUi, stepKEY );
        //debugger;
        // set our specific title, clear out the old content, destroy it, create the new, add it
        sas.ea.util.Step.dlgStepParms.setTitle( oBundle.getText( sTitle ) );

        // out with the old
        sas.ea.util.Step.dlgStepParms.destroyContent();

        // shouldn't have to, but we do anyway
        if ( sas.ea.util.Step.jsviewStepParmsDlgContent !== null ) {
            sas.ea.util.Step.jsviewStepParmsDlgContent.destroy();
        }

        // in with the new
        //debugger;
        sas.ea.util.Step.jsviewStepParmsDlgContent = new sap.ui.jsview( sView );
        sas.ea.util.Step.dlgStepParms.addContent( sas.ea.util.Step.jsviewStepParmsDlgContent );
    },

    stepLockHandler: function ( uidUi, stepKEY ) {
        //debugger;

        sas.ea.util.Step.verifyRepoOwnerAndRun( "OverrideLock.msg", "",
            //sas.ea.util.Step.stepRunHandlerDOIT,
            function () {
                sas.hc.m.MessageBox.warning( oBundle.getText("Lock.Repository.msg"), oBundle.getText("Lock.REPO.DLGTITLE"),
                    [SC.BTN_LOCK, sap.ui.commons.MessageBox.Action.CANCEL],
                    "dialogID",
                    function (sResult) {
                        //debugger;
                        if (sResult === SC.BTN_LOCK) {
                            SEA.log("UI", "stepLockHandler - LOCKED");
                            var projectID = SEA.aRp[SEA.iCurrentTab].oRepoMeta.id;
                            //var projectID = sas.ea.util.JobResults.getProjectUID(uidUi);
                            //var jobID = sas.ea.util.JobResults.getJobUID(uidUi);
                            //var stepID = sas.ea.util.JobResults.getStepUID(uidUi, stepKEY);

                            //debugger;
                            // if the lock button is visible, then change its state, else we must have been locked from the joblist
                            if ( sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-chkLock") ) {
                                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-chkLock").setVisible(false);      // once you lock...you're locked
                                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun").setVisible(false);       // once locked, you can't run anymore
                                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-status").setText(oBundle.getText("STEP.STATUS.LOCKED"));
                            }

                            // update in-memory
                            SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked = true;
                            // and the MT
                            rs.ProjectService.lockProject(projectID).resultHandler = function (result) {
                                // returns nothing so nothing to do
                                SEA.log("MTdata", "lockProject: " + result);

                                // make sure the joblist is up-to-date
                                sas.ea.util.MidTierMessage.updateJobListForCurrentTab();
                                //SEA.aRp[SEA.iCurrentTab].oObjMgr.updateBindings(true);
                                // globalCohortMetadata object will needs to be populated.  It needs to be updated with
                                // the new metaata from the most recent run.
                                     // need to seed the metadata for the subset query builder components
                                if ( SEA.lic.EA_PQS ) {
                                    rs.ProjectService.getDefaultParameters(SEA.aRp[SEA.iCurrentTab].oRepoMeta.id, "PS").resultHandler = function (result) {
                                        if (result) {
                                            SEA.aRp[SEA.iCurrentTab].oRepoMeta.globalCohortMetadata = $.parseJSON(result);
                                        }
                                    }
                                }
                            };
                        }
                    }//,
                    //sap.ui.commons.MessageBox.Action.NO
                );
            }
        );


        //sap.ui.commons.MessageBox.warning( oBundle.getText("Lock.Repository.msg"),
        //    sap.ui.commons.MessageBox.Icon.WARNING,
        //    oBundle.getText("Lock.REPO.DLGTITLE"),
        //    [sap.ui.commons.MessageBox.Action.OK, sap.ui.commons.MessageBox.Action.CANCEL, "Lock"],
        //    function (sResult) {
        //        debugger;
        //        if (sResult === sap.ui.commons.MessageBox.Action.OK) {
        //            SEA.log("UI", "stepLockHandler - LOCKED");
        //            var projectID = SEA.aRp[SEA.iCurrentTab].oRepoMeta.id;
        //            //var projectID = sas.ea.util.JobResults.getProjectUID(uidUi);
        //            //var jobID = sas.ea.util.JobResults.getJobUID(uidUi);
        //            //var stepID = sas.ea.util.JobResults.getStepUID(uidUi, stepKEY);
        //
        //            //debugger;
        //            // if the lock button is visible, then change its state, else we must have been locked from the joblist
        //            if ( sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-chkLock") ) {
        //                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-chkLock").setVisible(false);      // once you lock...you're locked
        //                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun").setVisible(false);       // once locked, you can't run anymore
        //                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-status").setText(oBundle.getText("STEP.STATUS.LOCKED"));
        //            }
        //
        //            // update in-memory
        //            SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked = true;
        //            // and the MT
        //            rs.ProjectService.lockProject(projectID).resultHandler = function (result) {
        //                // returns nothing so nothing to do
        //                SEA.log("MTdata", "lockProject: " + result);
        //
        //                // make sure the joblist is up-to-date
        //                sas.ea.util.MidTierMessage.updateJobListForCurrentTab();
        //                //SEA.aRp[SEA.iCurrentTab].oObjMgr.updateBindings(true);
        //            };
        //        }
        //    }//,
        //    //sap.ui.commons.MessageBox.Action.NO
        //);
    },

    disableRunButtons: function ( uidUi, stepKEY ) {

        // even though this says "Run", we also want to handle the Parms buttons

        // well...on second thought, we should disable all buttons when running a step
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( false );
        //sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnParms").setEnabled( false );

        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( false );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnParms").setEnabled( false );

        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PS + "-btnRun").setEnabled( true );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PS + "-btnParms").setEnabled( true );

        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRun").setEnabled( false );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnParms").setEnabled( false );

        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnRun").setEnabled( false );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnParms").setEnabled( false );

        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( false );
        //sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnParms").setEnabled( false );

    },


    enableCurrentStep: function ( uidUi, stepKEY ) {

        var ctrl;

        ctrl = sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun" );
        // enable both the Run & Parms buttons, making sure they are there (ex. VA has no parms btn)
        if ( ctrl ) {
            ctrl.setEnabled( true );
        }

        ctrl = sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnParms" );
        if ( ctrl  ) {
            ctrl.setEnabled( true );
        }
    },

    enableNextSteps: function ( uidUi, stepKEY, bRunAll ) {

        // if we're doing a RunAll, then only need to handle the "last" step
        var lastStepKEY = sas.ea.util.Step.getLastStepInJob(sas.ea.util.JobResults.getJobUID(uidUi));
        if ( bRunAll && (stepKEY !== lastStepKEY) ) {
            return;
        }

        // well...on second thought, since we disabled prior step run buttons, we need to turn them back on now
        switch ( stepKEY ) {
            case SC.STEP_KEY_EC:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( true );
                break;

            case SC.STEP_KEY_LV:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( true );   // now that auto-run reports are available after LV, then always enable this for "next" steps
                break;

            case SC.STEP_KEY_PS:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PS + "-btnRun").setEnabled( true );
                break;

            case SC.STEP_KEY_PA:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( true );   // now that auto-run reports are available after LV, then always enable this for "next" steps
                break;

            case SC.STEP_KEY_RA:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( true );   // now that auto-run reports are available after LV, then always enable this for "next" steps
                break;

            case SC.STEP_KEY_VA:
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnRun").setEnabled( true );
                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_VA + "-btnRun").setEnabled( true );   // now that auto-run reports are available after LV, then always enable this for "next" steps
                break;
        }

        /* not needed anymore since we're enabled it in the above switch
        // ACTUALLY...users may want to re-run current step as well...not logical, but I do what I'm told, so I'll also enable the passed step
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + stepKEY + "-btnRun").setEnabled( true );
        */

        // Are there any pending steps in the job? If so, Run All Pending buttons should be enabled.
        var bPend = false;
        allJobs:
            for (var i=0; i<SEA.aRp[SEA.iCurrentTab].oJobs.jobs.length; ++i) {
                if (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].jobID === sas.ea.util.JobResults.getJobUID(uidUi)){
                    // skip the VA step, since it is not part of the Run All
                    for (var j=0; j<SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps.length-1; ++j){
                        if (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps[j].status === SC.STEP_STATUS_PENDING || SEA.aRp[SEA.iCurrentTab].oJobs.jobs[i].steps[j].status === SC.STEP_STATUS_ERROR) {
                            bPend = true;
                            break allJobs;
                        }
                    }
                }
            }
        // If there are no pending steps in this job, disable Run All Pending buttons; otherwise enable
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnRunAll").setEnabled( bPend );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnRunAll").setEnabled( bPend );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnRunAll").setEnabled( bPend );

        // also we need to turn parms buttons back on
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_LV + "-btnParms").setEnabled( true );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PS + "-btnParms").setEnabled( true );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_PA + "-btnParms").setEnabled( true );
        sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_RA + "-btnParms").setEnabled( true );
    },

    enablePrevSteps: function ( uidUi, stepKEY, bRunAll ) {

        // used when steps are cancelled, we want to revert back to where the previous step was
        // successful, which should allow this step to be runnable
        // so, we'll just take the passed step and subtract 1 step from it and run it through enableNextSteps()

        // saspfj, bRunAll added to "next", so added here as well, need to handle this...duh

        switch ( stepKEY ) {
            case SC.STEP_KEY_EC:
                // there is no previous step, so just enable Run for the EC
                sap.ui.getCore().byId( "FLOW" + uidUi + "STEPPANEL_" + SC.STEP_KEY_EC + "-btnRun").setEnabled( true );
                break;

            case SC.STEP_KEY_LV:
                sas.ea.util.Step.enableNextSteps( uidUi, SC.STEP_KEY_EC, bRunAll );
                break;

            case SC.STEP_KEY_PS:
                sas.ea.util.Step.enableNextSteps( uidUi, SC.STEP_KEY_EC, bRunAll );
                break;

            case SC.STEP_KEY_PA:
                sas.ea.util.Step.enableNextSteps( uidUi, SC.STEP_KEY_LV, bRunAll );
                break;

            case SC.STEP_KEY_RA:
                sas.ea.util.Step.enableNextSteps( uidUi, SC.STEP_KEY_PA, bRunAll );
                break;

            case SC.STEP_KEY_VA:
                sas.ea.util.Step.enableNextSteps( uidUi, SC.STEP_KEY_RA, bRunAll );
                break;
        }
    },

// saspfj, this will be part of the changeover to using HC icons and colors
    stepColorFromStatus: function ( sStatus ) {
        switch ( sStatus ) {
            //case SC.STEP_STATUS_DISABLED:   "white";
            case SC.STEP_STATUS_PENDING:    return "grey";
            case SC.STEP_STATUS_PROCESSING: return "spin";
            case SC.STEP_STATUS_SUCCESS:    return "Success";
            case SC.STEP_STATUS_WARNING:    return "Warning";
            case SC.STEP_STATUS_ERROR:      return "Error";
        }
        return "grey";
    },


    //*********************************************************************
    // START old update flow code form app.js

    hideAllStepPanelsAndFlows: function ( oJob ) {
        // debugger;

        var ctrl;

        // hide all step panels
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_EC")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_LV")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_PS")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_PA")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_RA")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_VA")) {
            ctrl.setVisible(false);
        }

        // hide all step nodes
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODEEC")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODELV")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODEPS")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODEPA")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODERA")) {
            ctrl.setVisible(false);
        }
        if (ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODEVA")) {
            ctrl.setVisible(false);
        }


    },

    updateFlowChart: function ( oJob, uidUi ) {

        var ctrl = null;
        var sImg = "";

        // update the flow
        for (var z = 0; z < oJob.steps.length; ++z) {
            ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "NODE" + oJob.steps[z].progID);
            if (ctrl) {
                sas.ea.util.Step.updateStepNode(ctrl, oJob.steps[z], ((oJob.jobType === SC.JOB_TYPE_ANALYSIS) || (oJob.jobType === SC.JOB_TYPE_SUBSET)));
            }

            // track which reports are available before the panels are rendered
            sas.ea.util.Step.updateStepReportsAvailable(uidUi, oJob.steps[z].progID, oJob.steps[z].status);

            ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "STEPPANEL_" + oJob.steps[z].progID);
            if (ctrl) {
                sas.ea.util.Step.updateStepPanel(uidUi, ctrl, oJob.steps, z);
            }
        }

        // update the flow background
        var ctrlImg = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "BACK");
        //debugger;
        if (ctrlImg) {
            if (oJob.jobType === SC.JOB_TYPE_SUBSET) {
                sImg = "html/resources/sas/ea/images/FlowBackground31-3.png";
            } else {
                sImg = "html/resources/sas/ea/images/FlowBackground31-" + oJob.steps.length + ".png";
            }
            ctrlImg.setSrc(sImg);
        }
    },

    updateFlowAndPanels: function ( oJob ) {
        //debugger;
        //alert("updateFlowAndPanels() called");

        var ctrl = null;
        var sTxt = "";
        var bP = false; // any steps Processing?
        var bW = false; // any steps with Warnings?
        var bE = false; // any steps with Errors?
        var bC = true;  // is job Complete? (whistle now - always look on the bright side of life...)

        // concurrency, so we know which job is active
        //debugger;
        SEA.OpenJobID = oJob.jobID;

        // saspfj, temp fix until iFlow is gone
        oJob.iFlow = sas.ea.util.JobResults.getUiUID( oJob.jobID );
        var uidUi = sas.ea.util.JobResults.getUiUID( oJob.jobID );

        // since we can't call updateStepReportsAvailable() below until this returns, we have all the code inside the async return here
        var stepID = "";
        //if ( ((oJob.jobType !== SC.JOB_TYPE_CONSTRUCTION) && (oJob.jobType !== SC.JOB_TYPE_SUBSET)) && ((typeof sas.ea.util.Step.dlgLoadLASRoptions.jsonParms === SC.UNDEFINED) || (sas.ea.util.Step.dlgLoadLASRoptions.jsonParms === null)) ) {
        if ( oJob.jobType === SC.JOB_TYPE_ANALYSIS ) {

            // need to find the ID for the VA step
            for (var w = 0; w < oJob.steps.length; ++w) {
                if (oJob.steps[w].progID === SC.STEP_KEY_VA) {
                    stepID = oJob.steps[w].stepID;
                    break;
                }
            }

            // now get the VA step's parms
            rs.ProjectService.getParameters(oJob.projectID, oJob.jobID, stepID).resultHandler = function (result) {
                SEA.log("parms", "JSON:" + result);
                if (result) {
                    //debugger;

                    //// since I can't figure out a way to pass something into CreateContent()
                    //sas.ea.util.Step.dlgLoadLASRoptions.jsonParms = $.parseJSON(result);
                    //
                    //// shortcut var for use below
                    //var aRpts = sas.ea.util.Step.dlgLoadLASRoptions.jsonParms.reports;

                    // remember this job's VA parms object
                    var oVAparms = $.parseJSON(result);
                    sas.ea.util.JobResults.setVAparmsForUID( uidUi, oVAparms );
                    sas.ea.util.Step.dlgLoadLASRoptions.jsonParms = oVAparms;       // rather than change all code that uses this, use
                    var aRpts = oVAparms.reports;

                    // assume no reports are available
                    for (var x = 0; x < aRpts.length; ++x) {
                        aRpts[x].bAvail = false;
                        SEA.log( "VAparms", "aRpts[" + x + "] auto:" + aRpts[x].auto + " included:" + aRpts[x].included + " name:" + aRpts[x].name + ", ID:" + aRpts[x].progID + " key:" + aRpts[x].reportID + " bAvail:" + aRpts[x].bAvail );
                    }

                    // replicated code, see below
                    sas.ea.util.Step.hideAllStepPanelsAndFlows( oJob );
                    sas.ea.util.Step.updateFlowChart( oJob, uidUi );
                }
            };
        } else {
            // non Analysis jobs don't have VA reports
            //sas.ea.util.Step.dlgLoadLASRoptions.jsonParms = null;
            sas.ea.util.JobResults.setVAparmsForUID( uidUi, null );

            // replicated code, see above
            sas.ea.util.Step.hideAllStepPanelsAndFlows( oJob );
            sas.ea.util.Step.updateFlowChart( oJob, uidUi );
        }

        // now add a function that uses the above array
        sas.ea.util.Step.dlgLoadLASRoptions.areReportsAvailable = function (uidUi) {

            var oVAparms = sas.ea.util.JobResults.getVAparmsForUID( uidUi );

            // EC and PQS jobs don't have VA parms
            if ( oVAparms === null ) {
                return false;
            }

            // if any VA reports are available, then enable VA's run button
            for (var x = 0; x < oVAparms.reports.length; ++x) {
                if ( oVAparms.reports[x].bAvail ) {
                    return true;
                }
            }

            // S1221044, since default reports are available after LV, if LV is SUCCESSFUL, then return true
            var jobId = sas.ea.util.JobResults.getJobUID( uidUi );
            if ( sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_LV" + "-status").getText() === oBundle.getText("STEP.STATUS.SUCCESS") ) {
                 return true;
            }

            return false;
        };
    },

    // this updates the step status node in the flow
    updateStepNode: function ( ctrl, step, bNotEC ) {

        var sTip = "";
        var sIcon = "";
        var sColor = "";

        switch ( step.progID ) {
            case SC.STEP_KEY_EC: sIcon = 'EC';   sTip = oBundle.getText("StepPanels.PanelEC");   break;
            case SC.STEP_KEY_LV: sIcon = 'LV';   sTip = oBundle.getText("StepPanels.PanelLV");   break;
            case SC.STEP_KEY_PS: sIcon = 'PS';   sTip = oBundle.getText("StepPanels.PanelPS");   break;
            case SC.STEP_KEY_PA: sIcon = 'PA';   sTip = oBundle.getText("StepPanels.PanelPA");   break;
            case SC.STEP_KEY_RA: sIcon = 'RA';   sTip = oBundle.getText("StepPanels.PanelRA");   break;
            case SC.STEP_KEY_VA: sIcon = 'VA';   sTip = oBundle.getText("StepPanels.PanelVA");   break;
        }

        switch ( step.status ) {
            case SC.STEP_STATUS_DISABLED:   sColor = "white";    break;
            case SC.STEP_STATUS_PENDING:    sColor = ""; break; // (step.progID === SC.STEP_KEY_VA) ? "white" : "Pending";   break;
            case SC.STEP_STATUS_PROCESSING: sColor = "spin";     break;
            case SC.STEP_STATUS_SUCCESS:    sColor = (step.progID === SC.STEP_KEY_EC) ? "" : "Success";   break;
            //case SC.STEP_STATUS_SUCCESS:    sColor = "Success";  break;
            case SC.STEP_STATUS_WARNING:    sColor = "Warning";  break;
            case SC.STEP_STATUS_ERROR:      sColor = "Error";    break;
        }

        if ( step.status === SC.STEP_STATUS_DISABLED ) {
            ctrl.setVisible( false );
            ctrl.setIcon("html/resources/sas/ea/images/" + sIcon + sColor + ".png");
        } else {
            ctrl.setVisible( true );
            //ctrl.setIcon("html/resources/sas/ea/images/" + sIcon + sColor + ".png");
            // for analysis jobs, the EC node doesn't look like a node
            if ( bNotEC && (step.progID === SC.STEP_KEY_EC) ) {
                if ( SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked ) {
                    ctrl.setIcon("html/resources/sas/ea/images/" + sIcon + "locked.png");
                } else {
                    ctrl.setIcon("html/resources/sas/ea/images/" + sIcon + ".png");
                }
            } else {
                ctrl.setIcon("html/resources/sas/ea/images/" + sIcon + step.status + "Node.png");
            }
        }
    },

    // saspfj, ToDO, review this and the renderStepUI() in JobResults.js to refactor & reuse common code
    // this updates the step status detail panel
    updateStepPanel: function ( uidUi, ctrl, steps, iInd ) {
        //debugger;
        SEA.log( "Render", "updateStepPanel: " + steps[iInd].progID + "-" + steps[iInd].status + ", project:" + sas.ea.util.JobResults.getProjectUID(uidUi) + ", job:" + sas.ea.util.JobResults.getJobUID(uidUi) );

        // the current step
        var step = steps[iInd];

        // should step panel even be displayed
        if ( step.status === SC.STEP_STATUS_DISABLED ) {
            ctrl.setVisible( false );
            // nothing else to do
            return;
        } else {
            ctrl.setVisible( true );
        }

        // if this step panel has "new" results, then modify the label on it
        var jobID = sas.ea.util.JobResults.getJobUID(uidUi);
        for ( var z=0; z < SEA.aRp[SEA.iCurrentTab].aNew.length; ++z ) {
            var oNew = SEA.aRp[SEA.iCurrentTab].aNew[z];

            if ( (jobID === oNew.jobID) && (step.progID === oNew.stepKEY) ) {
                var sId = "FLOW" + uidUi + "STEPPANEL_" + step.progID + "-label1";
                sap.ui.getCore().byId(sId).setText( "*  " + sap.ui.getCore().byId(sId).getText() );
                SEA.aRp[SEA.iCurrentTab].aNew.splice( z, 1 );

                // if that was the last new results for this repo, then we need to update the tab text
                if ( SEA.aRp[SEA.iCurrentTab].aNew.length < 1 ) {
                    sas.ea.util.Overview.genRepoNameAndTip( SEA.iCurrentTab );
                }
                break;
            }
        }

        // update status
        // VA is SPECIAL
        if ( step.progID === SC.STEP_KEY_VA ) {
            sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-status").setText(sas.ea.util.JobResults.getStepStatusTextVA(step.status));
        } else {
            sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-status").setText(sas.ea.util.JobResults.getStepStatusText(step.status, SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked));
            if ( (step.progID === SC.STEP_KEY_EC) && SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked ) {
                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-statusIcon").setSrc( "html/resources/sas/ea/images/lock.png" );
            }
        }

        // should run button be enabled, assume disabled
        var bFlag = false;
        switch ( step.status ) {
            case SC.STEP_STATUS_PENDING:
                // if this step is EC, then pending always allows to be run
                if ( step.progID === SC.STEP_KEY_EC ) {
                    bFlag = true;
                } else if ( step.progID === SC.STEP_KEY_PS ) {
                    bFlag = false; // assume false, but we'll know for sure after the call below
                    // for PS we have to get the parms to see if an expression has been created yet.  If so, then Run can be enabled
                    rs.ProjectService.getParameters( sas.ea.util.JobResults.getProjectUID(uidUi),sas.ea.util.JobResults.getJobUID(uidUi),sas.ea.util.JobResults.getStepUID(uidUi, SC.STEP_KEY_PS) ).resultHandler = function (result) {
                        if (result) {
                            var oPs = $.parseJSON(result);
                            if (oPs.queryData !== undefined) {
                                sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-btnRun").setEnabled( true );
                            }
                        }
                    };
                } else if ( (steps[iInd-1].status === SC.STEP_STATUS_SUCCESS) || (steps[iInd-1].status === SC.STEP_STATUS_WARNING) ) {
                    // if this one is pending, see if prior step was success or warning
                    // if so, then user can run this step
                    bFlag = true;
                }
                break;
            case SC.STEP_STATUS_PROCESSING:                 break;
            case SC.STEP_STATUS_SUCCESS:    bFlag = true;   break;  // "they" want to be able to rerun the step...although there's no reason why  :-(
            case SC.STEP_STATUS_WARNING:    bFlag = true;   break;  // allow then to re-run
            case SC.STEP_STATUS_ERROR:      bFlag = true;   break;  // allow then to re-run
        }

        // VA is SPECIAL
        if ( step.progID === SC.STEP_KEY_VA ) {
            sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-btnRun").setEnabled( sas.ea.util.Step.dlgLoadLASRoptions.areReportsAvailable(uidUi) );
        } else {
            sap.ui.getCore().byId("FLOW" + uidUi + "STEPPANEL_" + step.progID + "-btnRun").setEnabled(bFlag);
        }
    },

    updateStepReportsAvailable: function ( uidUi, stepKEY, eStatus ) {
        //debugger;

        var bRun = false;
        if ( (eStatus === SC.STEP_STATUS_SUCCESS) || (eStatus === SC.STEP_STATUS_WARNING) ) {
            bRun = true;
        }

        // saspfj, NOTE!, make sure this code is similar to code in JobResults.clearStepArtifactsVA()

        var oVAparms = sas.ea.util.JobResults.getVAparmsForUID( uidUi );

        // EC and PQS jobs don't have VA parms
        if ( oVAparms === null ) {
            return;
        }

        switch ( stepKEY ) {
            //case SC.STEP_KEY_EC:
                // none for EC :-(
                //break;

            //case SC.STEP_KEY_LV:
                // none for EC :-(
                //break;

            case SC.STEP_KEY_PA:
                SEA.log( "VAparms", "2,3&4 available:" + bRun );
                oVAparms.reports[2].bAvail = bRun;
                oVAparms.reports[3].bAvail = bRun;
                oVAparms.reports[4].bAvail = bRun;
                break;

            case SC.STEP_KEY_RA:
                SEA.log( "VAparms", "5&6 available:" + bRun );
                oVAparms.reports[5].bAvail = bRun;
                oVAparms.reports[6].bAvail = bRun;
                break;
        }
    },

    // saspfj, remove this intermediate step sometime
    updateActiveJob: function () {
        //debugger;
        SEA.log( "Render", "updateActiveJob: " + SEA.oActJob.projectID + ":" + SEA.oActJob.jobID );

        // if we don't have an active job, then nothing to do
        if ( SEA.oActJob === null ) {
            return;
        }

        // if this is an Anlysis job, then add a successful EC step, if we haven't already
        if ( ((SEA.oActJob.jobType === SC.JOB_TYPE_ANALYSIS)||(SEA.oActJob.jobType === SC.JOB_TYPE_SUBSET)) && (SEA.oActJob.steps[0].progID !== SC.STEP_KEY_EC) ) {
            SEA.oActJob.steps.splice( 0, 0, {progID:SC.STEP_KEY_EC, status:SC.STEP_STATUS_SUCCESS} );
        }
        sas.ea.util.Step.updateFlowAndPanels( SEA.oActJob );

        var jobInfo = SEA.oActJob;
        var uidUi = sas.ea.util.JobResults.getUiUID( SEA.oActJob.jobID );

        // make sure the job status is correct
        var ctrlStatus;
        if ( ctrlStatus = sap.ui.getCore().byId("FLOW"+uidUi+"RS") ) {
            switch (jobInfo.status) {
                case SC.JOB_STATE_PENDING:      ctrlStatus.setText(oBundle.getText("JOB_STATE_PENDING"));    break;
                case SC.JOB_STATE_PROCESSING:   ctrlStatus.setText(oBundle.getText("JOB_STATE_PROCESSING")); break;
                case SC.JOB_STATE_SUCCESS:      ctrlStatus.setText(oBundle.getText("JOB_STATE_SUCCESS"));    break;
                case SC.JOB_STATE_ERROR:        ctrlStatus.setText(oBundle.getText("JOB_STATE_ERROR"));      break;
            }
        }

        // if this is an Analysis/Subset job, need to find its EC job/step
        if ( (jobInfo.jobType === SC.JOB_TYPE_ANALYSIS) || (jobInfo.jobType === SC.JOB_TYPE_SUBSET) ) {
            //debugger;

            // allow user to add steps to Analysis jobs (if they don't have them ALL already
            // saspfj, BackLog, commenting out for now until story is moved off of backlog
            //if ( (jobInfo.jobType === SC.JOB_TYPE_ANALYSIS) && (jobInfo.steps.length < 4) ) {
            //    sap.ui.getCore().byId("FLOW" + uidUi + "-AddRemoveBtn").setVisible(true);
            //}

            var sECjobID = "";
            // look for the EC job in this repository
            for ( var x=0; x < SEA.aRp[SEA.iCurrentTab].oJobs.jobs.length; ++x ) {
                if ( (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[x].jobType === "Construction") || (SEA.aRp[SEA.iCurrentTab].oJobs.jobs[x].jobType === "Combined") ) {
                    sECjobID = SEA.aRp[SEA.iCurrentTab].oJobs.jobs[x].jobID;
                    break;
                }
            }
            // if we found it, then load it
            if ( sECjobID !== "" ) {
                //get EC step and insert into this jobs's step array
                SEA.log( "MTdata", "For Analysis jobs - getJob() project:" + SEA.oActJob.projectID + ", job:" + sECjobID );
                //debugger;
                rs.ProjectService.getJob(SEA.oActJob.projectID, sECjobID).resultHandler = function (ecResult) {
                    //debugger;
                    if (ecResult !== "") {
                        var ecJobInfo = $.parseJSON(ecResult);
                        // now look for the EC step and splice it into the Analysis job steps as its own
                        for (var y = 0; y < ecJobInfo.steps.length; ++y) {
                            if (ecJobInfo.steps[y].progID === "EC") {   // saspfj, use constant
                                // before splicing, slight DNA transplant - fake its jobID
                                ecJobInfo.steps[y].jobID = SEA.oActJob.jobID;
                                jobInfo.steps.splice(0, 1, ecJobInfo.steps[y]);

                                // since we're splicing in the shared EC job, we need to also splice in the stepIDs
                                // so when the user wants to do a data preview on an EC step dataset, then can
                                //debugger;
                                sas.ea.util.JobResults.addStepIDforSharedEC( SEA.oActJob.jobID, ecJobInfo.steps[y].stepID, ecJobInfo.jobID );
                                break;                                    }
                        }
                    }
                    // duplicated because of ASYNC returns in this usage
                    // render EC and all the Analysis job's steps
                    for (var z = 0; z < jobInfo.steps.length; ++z) {
                        sas.ea.util.JobResults.renderStepUI( jobInfo.projectID, jobInfo.steps[z], SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked, jobInfo );
                    }
                    // done to set RunAll button state
                    SEA.lastJobForRunAllCheck( jobInfo.projectID, jobInfo.jobID );
                    //SEA.hideBusy( "AFTER - updateActiveJob() 111" );
                };
            }
        } else {
            // duplicated because of ASYNC returns in above usage
            // already have the EC step, so render away...
            for ( var w=0; w < jobInfo.steps.length; ++w ) {
                sas.ea.util.JobResults.renderStepUI( jobInfo.projectID, jobInfo.steps[w], SEA.aRp[SEA.iCurrentTab].oRepoMeta.bLocked, jobInfo );
            }
            // done to set RunAll button state
            SEA.lastJobForRunAllCheck( jobInfo.projectID, jobInfo.jobID );
            //SEA.hideBusy( "AFTER - updateActiveJob() 222" );
        }
    },

    updateHistory: function ( oJob ) {


        ////saspfj, if we're doing history for 3.1, then clean up this code
        //var ctrl = sap.ui.getCore().byId("FLOW" + oJob.iFlow + "HISTORY");
        //if ( ctrl ) {
        //    rs.ProjectService.getProjectHistory(oJob.sId).resultHandler = function( result ) {
        //        var ctrl2 = sap.ui.getCore().byId("FLOW" + getActiveJob().iFlow + "HISTORY");
        //        if ( ctrl2 ) {
        //            ctrl2.setText(result);
        //        }
        //    }
        //}
    },

    // END old update flow code form app.js
    //*********************************************************************

    placeholderForCommas: function () {}
};
