// (c) 2015, SAS Institute Inc.

sap.ui.jsview("sas.ea.view.DATASETalbum", {

    getControllerName: function() {
        //return "sas.ea.view.DATASETalbum";
    },

    createContent: function(controller) {

        var hLayout = new sap.ui.layout.HorizontalLayout({ id:"datasetvHlay", width:"100%", height:"100%" });

        hLayout.addContent(
            //new sap.ui.layout.VerticalLayout({ id:"datasetvLeft" }),
            new sap.ui.core.HTML({ id:"datasetvLeftP",
                content : "<div id='datasetvLeft' style='overflow-y:auto'>"
            })
        );
        hLayout.addContent(
            new sap.ui.core.HTML({ id:"datasetvRight",
                content : "<iframe id='datasetvIFrame' src=''> style='padding-left:24px;'"
            })
        );

        sas.ea.util.JobResults.dlgDATASETalbum.runProcPrint = function ( iInd, sPath, sPriority ) {
            //debugger;

            //sap.ui.getCore().byId('dpdRefreshBtn').setEnabled( false );  // only allow 1 execution at a time

            var sLib = "datalib";   // magic string from Cummins
            var sData = sPath;//sas.ea.util.Step.dlgDataPreview.sDataset;
            var sRows = 100;//sap.ui.getCore().byId('rows').getSelectedKey();
            var sTitle = 'TITLE1 ' + oBundle.getText("DataPreview.First.txt") + sRows + oBundle.getText("DataPreview.Rows.txt")+'; ';
            var sProc = 'proc print data=' + sLib + "." + sData + ' (OBS=' + sRows + ') label; run;';
            var sCode = sTitle + sProc;
            SEA.log( "SAScode", "dlgDATASETalbum-code: " + sCode );

            // saspfj, refactor both uses into single code piece
            // since we can have multiple proc print jobs submitted, we need to pass more info to/from MT
            var oPPreq = {};
            oPPreq.id = "#datasetvIFrame";
            oPPreq.iInd = iInd;

            var request =
            {
                "executionType": SC.TYPE_PRINT,
                //"requestID": "#datasetvIFrame",
                "requestID": JSON.stringify( oPPreq ),
                "projectID": sas.ea.util.JobResults.dlgDATASETalbum.projectID,
                "jobID": sas.ea.util.JobResults.dlgDATASETalbum.jobID,
                "stepID": sas.ea.util.JobResults.dlgDATASETalbum.stepID,
                "jobName": "SAS code from UI",
                "execName": "cam",
                "code": sCode
            };
            //debugger;
            SEA.log( "SAScodeREQUEST", "dlgDATASETalbum-request:" + JSON.stringify(request) );
            rs.ExecutionService.batchRequest(JSON.stringify(request), SC.PROD_SEA, SC.METHOD_SASCODE, sPriority).resultHandler = function (result) {
                //debugger;

                // saspfj, determine if we need to do anything with these
                if (result !== null) {
                    SEA.log("SAScode", "batchRequest - result:" + result);
                }
            };

        };

        sas.ea.util.JobResults.dlgDATASETalbum.displayDATASET = function ( iInd, sName, stepKEY, sDATASET ) {

            sas.ea.util.JobResults.dlgDATASETalbum.iInd = iInd;                 // remember which dataset is current

            var aDATASETs = sas.ea.util.JobResults.dlgDATASETalbum.aDATASETs;   // simplify code below

            // check to see if job has finished running yet
            if ( aDATASETs[iInd].sUrl === "" ) {
                $('#datasetvIFrame').attr( 'src', oBundle.getText("DataPreviewDialog.Loading.html") );
            } else {
                //debugger;
                sas.ea.util.Misc.loadIFrameWithProcPrintHTML( '#datasetvIFrame', aDATASETs[iInd].sUrl );
	              console.log("Add MT call here - 4, dataset album: " + SEA.aRp[SEA.iCurrentTab].oRepoMeta.id + ", " + sName);
	              rs.auditDataView( SEA.aRp[SEA.iCurrentTab].oRepoMeta.id, sName+".sas7bdat", null );
            }

            // update the dialog title
            var sTmp = "";
            switch ( stepKEY ) {
                case SC.STEP_KEY_EC: sTmp = oBundle.getText( "StepPanels.PanelEC" );    break;
                case SC.STEP_KEY_LV: sTmp = oBundle.getText( "StepPanels.PanelLV" );    break;
                case SC.STEP_KEY_PS: sTmp = oBundle.getText( "StepPanels.PanelPS" );    break;
                case SC.STEP_KEY_PA: sTmp = oBundle.getText( "StepPanels.PanelPA" );    break;
                case SC.STEP_KEY_RA: sTmp = oBundle.getText( "StepPanels.PanelRA" );    break;
            }
            sTmp += (" - " + sDATASET);
            sas.ea.util.JobResults.dlgDATASETalbum.setTitle( sTmp );

            // make previous thumbnail normal
            if ( sas.ea.util.JobResults.dlgDATASETalbum.iPrev !== -1 ) {
                $("#datasetvDiv" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).css('background-color', '');
                $("#datasetvSpanR" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).show("slow");
                //$("#datasetvDivI" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).fadeTo("slow", 1);
            }
            // this is now the "previous" thumbnail
            sas.ea.util.JobResults.dlgDATASETalbum.iPrev = iInd;

            // make this thumbnail different
            $("#datasetvDiv" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).css('background-color', '#d0d0d0');
            $("#datasetvSpanR" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).hide("slow");
            //$("#datasetvDivI" + sas.ea.util.JobResults.dlgDATASETalbum.iPrev).fadeTo("slow", 0);
        };

        sas.ea.util.JobResults.dlgDATASETalbum.loadDATASETs = function ( stepKEY ) {

            var aDATASETs = sas.ea.util.JobResults.dlgDATASETalbum.aDATASETs;   // simplify code below

            var oLeft = sap.ui.getCore().byId("datasetvLeft");
            //var iWid = $("#datasetvLeft").width();
            $("#datasetvDlg-scrollCont").css("padding", "0");
            $("#datasetvDlg-scrollCont").css("overflow", "hidden");
            var iWid = $("#datasetvDlg-scroll").width();
            var iHgt = $("#datasetvDlg-scroll").height();
            sas.ea.util.JobResults.dlgDATASETalbum.iWid = iWid * 0.74; // remember for doing animations above
            var iTnWid = (iWid * 0.24) - 24;    // 24 for the possible scrollbar
            var iTnHgt = (iHgt - (aDATASETs.length * 51)) / aDATASETs.length;   // just split it across all DATASETs and let's see how that works, 50 is space between thumbnail datasets

            // let's not get too small, yes, I know I could have used "min" above, but I like this logic better
            if ( iTnHgt < 150 ) {
                iTnHgt = 150;
            }

            SEA.log( "DATASETalbum", "w,h[" + iWid + "," + iHgt + "], TN[" + iTnWid + "," + iTnHgt + "]" );
            var sStructure = oBundle.getText("dataset.structure.txt");
            var sComment = oBundle.getText("dataset.comment.txt");
            for ( var x=0; x < aDATASETs.length; ++x ) {
                //debugger;
                if ( x > 0 ) {
                    // some whitespace between thumbnails, but not at the end
                    $("#datasetvLeft").append( "<p> </p>" );
                }
                SEA.log( "DATASETalbum", "DATASET: " + aDATASETs[x] );
                var sLabel = aDATASETs[x].name.replace(/_/gi, " "); // change underscores to spaces for better label wrapping
                //var sSize = sas.ea.util.JobResults.genPrettySize(aDATASETs[x].size);
                var sSize = "<span style='font-size:small; font-variant:small-caps;'>" + sas.ea.util.JobResults.genPrettySize(aDATASETs[x].size) + "</span><br />";
                var sName = aDATASETs[x].name;

                // get structure & comment for each dataset if they exist, else they're blank
                var sKeyS = aDATASETs[x].name + ".structure.txt";
                var sResS = oBundle.getText( sKeyS );
                //sResS = sResS === sKeyS ? "" : (sStructure + " " + sResS + "<br />");
                sResS = sResS === sKeyS ? "" : (sResS + "<p> </p>");
                var sKeyC = aDATASETs[x].name + ".comment.txt";
                var sResC = oBundle.getText( sKeyC );
                //sResC = sResC === sKeyC ? "" : (sComment + " " + sResC);
                sResC = sResC === sKeyC ? "" : (sResC + "");

                SEA.log( "DATASETalbum", "clickURL:" + "$(\"#datasetvIFrame\").attr( \"src\", \"" + sName + "\" );" );
                var sTN =
                    //"<div style='width:" + iTnWid + "px; cursor:pointer;' onclick='$(\"#datasetvIFrame\").attr( \"src\", \"" + sUrl + "\" );'>" +
                    //"<div style='width:" + iTnWid + "px; cursor:pointer;' onclick='$(\"#datasetvIFrame\").attr( \"src\", \"" + sUrl + "\" );'>" +
                    "<div id='datasetvDiv" + x + "' style='width:" + iTnWid + "px; cursor:pointer;' " +
                    "onclick='sas.ea.util.JobResults.dlgDATASETalbum.displayDATASET( " + x + ",\"" + sName + "\", \"" + stepKEY + "\", \"" + sLabel + "\" );'>" +
                    "<span id='datasetvSpanL" + x + "' style='clear:both; padding-left:8px;'><strong>" + sLabel + "&nbsp;&nbsp</strong></span><span id='datasetvSpanR" + x + "' style='float:right;'>open &#10140;&nbsp;&nbsp;</span></div>" +

//                    "<div id='datasetvDivI" + x + "'><div style='clear:both; width:" + iTnWid + "px; height:" + iTnHgt + "px;'>" + sResS + sResC + "</div></div>";
                    "<div id='datasetvDivI" + x + "'><div style='clear:both; padding-left:24px; width:" + (iTnWid-24) + "px;'>" + sSize + sResS + sResC + "</div><hr /></div>";

                $("#datasetvLeft").append( sTN );
            }

            // there is no previous yet
            sas.ea.util.JobResults.dlgDATASETalbum.iPrev = -1;

            // we have to do this since SAP/HC doesn't play well with regular HTML/JS :-(
            setTimeout( function() {
                $("#datasetvHlay").width( iWid );
                $("#datasetvHlay").height( iHgt );
                $("#datasetvLeftP").width( iWid * 0.25 );
                $("#datasetvLeftP").height( iHgt * 0.99 );
                $("#datasetvLeft").width( iWid * 0.24 );
                $("#datasetvLeft").height( iHgt * 0.99 );
                $("#datasetvRight").width( iWid * 0.75 );
                $("#datasetvRight").height( iHgt * 0.99 );
                $("#datasetvIFrame").width( iWid * 0.74 );
                $("#datasetvIFrame").height( iHgt * 0.99 );

                // always load up the first one
                sas.ea.util.JobResults.dlgDATASETalbum.displayDATASET( 0, aDATASETs[0].name, stepKEY, aDATASETs[0].name.replace(/_/gi, " ") );
            }, 400 );
        };

        return hLayout;
    }

});
