// (c) 2015, SAS Institute Inc.

sap.ui.jsview("sas.ea.view.PDFalbum", {

    getControllerName: function() {
        //return "sas.ea.view.PDFalbum";
    },

    createContent: function(controller) {

        var hLayout = new sap.ui.layout.HorizontalLayout({ id:"pdfvHlay", width:"100%", height:"100%" });

        hLayout.addContent(
            //new sap.ui.layout.VerticalLayout({ id:"pdfvLeft" }),
            new sap.ui.core.HTML({ id:"pdfvLeftP",
                content : "<div id='pdfvLeft' style='overflow-y:auto'>"
            })
        );
        hLayout.addContent(
            new sap.ui.core.HTML({ id:"pdfvRight",
                //content : "<iframe id='dpdIFrame' src='" + oBundle.getText('DataPreviewDialog.Loading.html') + "' style='width:98%; height:88%;'>"
                content : "<iframe id='pdfvIFrame' src=''> style='padding-left:24px;'"
            })
        );

        // had to put this in its own function, since SAP/HC/someone decided to disable $("#id").click();
        sas.ea.util.JobResults.dlgPDFalbum.refresh = function () {
            //debugger;
        };

        sas.ea.util.JobResults.dlgPDFalbum.displayPDF = function ( iInd, sUrl, stepKEY, sPDF ) {
            // isolate just the name
            var sName = sUrl.substr( 0, sUrl.lastIndexOf("/") );
            sName = sName.substr( sName.lastIndexOf("/")+1 );
            console.log("Add MT call here - 3, pdf album: " + SEA.aRp[SEA.iCurrentTab].oRepoMeta.id + ", " + sName);
	          rs.auditDataView( SEA.aRp[SEA.iCurrentTab].oRepoMeta.id, sName+".pdf", null );

            // saspfj, NOTE:  all of these didn't work :-(
                //$('#pdfvIFrame').fadeTo( "slow", 0, function () {
                //    $('#pdfvIFrame').fadeTo( "slow", 1);
                //} );

                //$('#pdfvIFrame').animate( {'margin-left':'100%'}, "slow",
                //    function() {
                //        $('#pdfvIFrame').animate( {'margin-left':'0%'}, "slow");
                //    }
                //);

                //$('#pdfvIFrame').hide( "slow",
                //    function() {
                //        $('#pdfvIFrame').show("slow");
                //    }
                //);

            // saspfj, This animation works...but it's too busy...perhaps
            //$('#pdfvIFrame').animate( {'width':'10px'}, "slow",
            //    function() {
            //        $('#pdfvIFrame').attr( 'src', "" );
            //        $('#pdfvIFrame').animate( {'width':sas.ea.util.JobResults.dlgPDFalbum.iWid+'px'}, "slow",
            //            function () {
            //                $('#pdfvIFrame').attr( 'src', sUrl );
            //            }
            //        );
            //    }
            //);

            // load the pdf first
            $('#pdfvIFrame').attr( 'src', sUrl );

            // update the dialog title
            var sTmp = "";
            switch ( stepKEY ) {
                case SC.STEP_KEY_EC: sTmp = oBundle.getText( "StepPanels.PanelEC" );    break;
                case SC.STEP_KEY_LV: sTmp = oBundle.getText( "StepPanels.PanelLV" );    break;
                case SC.STEP_KEY_PS: sTmp = oBundle.getText( "StepPanels.PanelPS" );    break;
                case SC.STEP_KEY_PA: sTmp = oBundle.getText( "StepPanels.PanelPA" );    break;
                case SC.STEP_KEY_RA: sTmp = oBundle.getText( "StepPanels.PanelRA" );    break;
            }
            sTmp += (" - " + sPDF);
            sas.ea.util.JobResults.dlgPDFalbum.setTitle( sTmp );

            // make previous thumbnail normal
            if ( sas.ea.util.JobResults.dlgPDFalbum.iPrev !== -1 ) {
                $("#pdfvDiv" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).css('background-color', '');
                $("#pdfvSpanR" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).show("slow");
                $("#pdfvDivI" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).fadeTo("slow", 1);
            }
            // this is now the "previous" thumbnail
            sas.ea.util.JobResults.dlgPDFalbum.iPrev = iInd;

            // make this thumbnail different
            $("#pdfvDiv" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).css('background-color', '#d0d0d0');
            $("#pdfvSpanR" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).hide("slow");
            $("#pdfvDivI" + sas.ea.util.JobResults.dlgPDFalbum.iPrev).fadeTo("slow", 0);
        };

        sas.ea.util.JobResults.dlgPDFalbum.loadPDFs = function ( stepKEY ) {
            var aPDFs = sas.ea.util.JobResults.dlgPDFalbum.aPDFs;   // simplify code below
            var oLeft = sap.ui.getCore().byId("pdfvLeft");
            //var iWid = $("#pdfvLeft").width();
            $("#pdfvDlg-scrollCont").css("padding", "0");
            $("#pdfvDlg-scrollCont").css("overflow", "hidden");
            var iWid = $("#pdfvDlg-scroll").width();
            var iHgt = $("#pdfvDlg-scroll").height();
            sas.ea.util.JobResults.dlgPDFalbum.iWid = iWid * 0.74; // remember for doing animations above
            //$("pdfvHlay").width( iWid+"px" );
            //$("pdfvHlay").height( iHgt+"px" );
            //$("pdfvLeftP").width( (iWid * 0.25)+"px" );
            //$("pdfvLeftP").height( iHgt+"px" );
            //$("pdfvRight").width( (iWid * 0.75)+"px" );
            //$("pdfvRight").height( iHgt+"px" );
            //$("pdfvIFrame").width( (iWid * 0.74)+"px" );
            //$("pdfvIFrame").height( (iHgt * 0.99)+"px" );
            var iTnWid = (iWid * 0.24) - 24;    // 24 for the possible scrollbar
            //var iTnHgt = iTnWid * 0.50; // seems about right for thumbnail PDF
            var iTnHgt = (iHgt - (aPDFs.length * 51)) / aPDFs.length;   // just split it across all PDFs and let's see how that works, 50 is space between thumbnail pdfs

            // let's not get too small, yes, I know I could have used "min" above, but I like this logic better
            if ( iTnHgt < 150 ) {
                iTnHgt = 150;
            }

            SEA.log( "PDFalbum", "w,h[" + iWid + "," + iHgt + "], TN[" + iTnWid + "," + iTnHgt + "]" );
            for ( var x=0; x < aPDFs.length; ++x ) {
                //debugger;
                if ( x > 0 ) {
                    // some whitespace between thumbnails, but not at the end
                    $("#pdfvLeft").append( "<p> </p>" );
                }
                SEA.log( "PDFalbum", "PDF: " + aPDFs[x] );
                var sLabel = aPDFs[x].name.replace(/_/gi, " "); // change underscores to spaces for better label wrapping
                var sUrl = window.location.origin + SC.RESULTS_PATH + aPDFs[x].path;
                //var oFT = new sap.ui.core.HTML({
                //    content : "<span><strong>" + sLabel + "</strong></span><span style='float:right;'>open</span><br /><iframe src='" + sUrl + "' style='width:" + iWid + "px; height:" + iHgt + "px;'>"
                //});
                //oLeft.addContent( oFT );
                //$("#pdfvLeft").append( "<span style='clear:both;'><strong>" + sLabel + "</strong></span><span style='float:right;'>open &#10140;&nbsp;&nbsp;</span><br style='clear:both;'/><iframe src='" + sUrl + "' style='width:" + iTnWid + "px; height:" + iTnHgt + "px;'/><p />" );
                //$("#pdfvLeft").append( "<div style='cursor:pointer;' onclick='debugger; $(\"#pdfvIFrame\").attr( \"src\", " + sUrl + " );'><span style='clear:both;'><strong>" + sLabel + "</strong></span><span style='float:right;'>open &#10140;</span></div><br style='clear:both;'/><iframe src='" + sUrl + "' style='width:" + iTnWid + "px; height:" + iTnHgt + "px;'/><p />" );
                SEA.log( "PDFalbum", "clickURL:" + "$(\"#pdfvIFrame\").attr( \"src\", \"" + sUrl + "\" );" );
                var sTN =
                    //"<div style='width:" + iTnWid + "px; cursor:pointer;' onclick='$(\"#pdfvIFrame\").attr( \"src\", \"" + sUrl + "\" );'>" +
                    //"<div style='width:" + iTnWid + "px; cursor:pointer;' onclick='$(\"#pdfvIFrame\").attr( \"src\", \"" + sUrl + "\" );'>" +
                    "<div id='pdfvDiv" + x + "' style='width:" + iTnWid + "px; cursor:pointer;' " +
                    "onclick='sas.ea.util.JobResults.dlgPDFalbum.displayPDF( " + x + ",\"" + sUrl + "\", \"" + stepKEY + "\", \"" + sLabel + "\" );'>" +
                    "<span id='pdfvSpanL" + x + "' style='clear:both;'><strong>" + sLabel + "</strong></span><span id='pdfvSpanR" + x + "' style='float:right;'>open &#10140;&nbsp;&nbsp;</span></div>" +
                    "<div id='pdfvDivI" + x + "'><iframe src='" + sUrl + "' style='clear:both; width:" + iTnWid + "px; height:" + iTnHgt + "px;'/></div>";

                $("#pdfvLeft").append( sTN );
            }

            // there is no previous yet
            sas.ea.util.JobResults.dlgPDFalbum.iPrev = -1;

            // always load up the first one
            sas.ea.util.JobResults.dlgPDFalbum.displayPDF( 0, window.location.origin + SC.RESULTS_PATH + aPDFs[0].path, stepKEY, aPDFs[0].name.replace(/_/gi, " ") );

            // we have to do this since SAP/HC doesn't play well with regular HTML/JS :-(
            setTimeout( function() {
                $("#pdfvHlay").width( iWid );
                $("#pdfvHlay").height( iHgt );
                $("#pdfvLeftP").width( iWid * 0.25 );
                $("#pdfvLeftP").height( iHgt * 0.99 );
                $("#pdfvLeft").width( iWid * 0.24 );
                $("#pdfvLeft").height( iHgt * 0.99 );
                $("#pdfvRight").width( iWid * 0.75 );
                $("#pdfvRight").height( iHgt * 0.99 );
                $("#pdfvIFrame").width( iWid * 0.74 );
                $("#pdfvIFrame").height( iHgt * 0.99 );
            }, 400 );
        };

        //var iframe = new sap.ui.core.HTML({
        //    //content : "<iframe id='dpdIFrame' src='" + oBundle.getText('DataPreviewDialog.Loading.html') + "' style='width:98%; height:88%;'>"
        //    content : "<iframe id='pdfvIFrame' src='www.sas.com' style='width:98%; height:88%;'>"
        //});
        //vLayout.addContent( iframe );

        //return vLayout;
        return hLayout;
    }

});
