/*-- Copyright (c) 2017 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --*/ 
/*
$Revision: 1.1.2.23.6.1 $
$Date: 2017/10/05 14:55:48 $
Model         Episode Analytics 3.1
Subject Area  All Tables
Model Version 
Name          gen.sas
DBMS          Oracle
Created       9/8/2017 11:01:15 AM
* Copyright (c) 2017 by SAS Institute Inc., Cary, NC 27513
*/
%MACRO gen(AUTHDOMAIN=, USER=, PATH=, SCHEMA=, fileloc=);
%let connstr=;
%IF (&SCHEMA > "" AND %INDEX(&SCHEMA, ".") = 0) %then %LET SCHEMA=%str(&SCHEMA).;
PROC SQL NOERRORSTOP;
%if (&PATH > "") %then %do;
   %let connstr = &connstr PATH=&PATH;
%end;
%IF (&AUTHDOMAIN > "") %then %do;
   %let connstr=AUTHDOMAIN=&AUTHDOMAIN &connstr;
%end;
%else %do;
      %let connstr=DBPROMPT=YES USER=&USER &connstr;
      %end;
CONNECT TO ORACLE (&connstr);
  %include "&fileloc./admit_type_ref.sas";
  %include "&fileloc./claim_type.sas";
  %include "&fileloc./code_category.sas";
  %include "&fileloc./code_category_level.sas";
  %include "&fileloc./code_sets.sas";
  %include "&fileloc./code_set_values.sas";
  %include "&fileloc./code_type.sas";
  %include "&fileloc./code_vocabulary.sas";
  %include "&fileloc./complication_type.sas";
  %include "&fileloc./condition.sas";
  %include "&fileloc./condition_association.sas";
  %include "&fileloc./condition_assoc_rel_type.sas";
  %include "&fileloc./condition_assoc_set.sas";
  %include "&fileloc./condition_class.sas";
  %include "&fileloc./condition_filter.sas";
  %include "&fileloc./condition_filter_set.sas";
  %include "&fileloc./condition_specialty.sas";
  %include "&fileloc./condition_specialty_set.sas";
  %include "&fileloc./core_group.sas";
  %include "&fileloc./core_group_x_condition.sas";
  %include "&fileloc./core_grp_x_code_set_vals.sas";
  %include "&fileloc./discharge_status_ref.sas";
  %include "&fileloc./em_codes.sas";
  %include "&fileloc./em_code_set.sas";
  %include "&fileloc./episode_date_use.sas";
  %include "&fileloc./episode_definition.sas";
  %include "&fileloc./episode_definition_group.sas";
  %include "&fileloc./episode_rule.sas";
  %include "&fileloc./episode_rule_component.sas";
  %include "&fileloc./episode_rule_component_signal.sas";
  %include "&fileloc./episode_source.sas";
  %include "&fileloc./epi_def_x_code_set_vals.sas";
  %include "&fileloc./epi_def_x_epi_def_group.sas";
  %include "&fileloc./epi_def_x_subtype_group.sas";
  %include "&fileloc./exclude_code_type.sas";
  %include "&fileloc./facility_group.sas";
  %include "&fileloc./facility_group_x_facility_ref.sas";
  %include "&fileloc./facility_ref.sas";
  %include "&fileloc./file_set.sas";
  %include "&fileloc./file_set_status.sas";
  %include "&fileloc./gender_ref.sas";
  %include "&fileloc./haf_audit.sas";
  %include "&fileloc./major_diag_category_ref.sas";
  %include "&fileloc./pa_cond_class_method.sas";
  %include "&fileloc./pa_cond_class_method_set.sas";
  %include "&fileloc./pa_method.sas";
  %include "&fileloc./pa_method_x_cond_class.sas";
  %include "&fileloc./place_of_service_ref.sas";
  %include "&fileloc./pqs_field.sas";
  %include "&fileloc./pqs_field_byvar.sas";
  %include "&fileloc./pqs_field_datefield.sas";
  %include "&fileloc./pqs_field_group.sas";
  %include "&fileloc./pqs_table.sas";
  %include "&fileloc./provider_specialty.sas";
  %include "&fileloc./race_ref.sas";
  %include "&fileloc./risk_factor_group.sas";
  %include "&fileloc./risk_factor_grp_x_code_set_val.sas";
  %include "&fileloc./risk_factor_set.sas";
  %include "&fileloc./rsk_fctr_set_x_rsk_fctr_grp.sas";
  %include "&fileloc./sea_job.sas";
  %include "&fileloc./sea_ra_analysis_macros.sas";
  %include "&fileloc./sea_ra_class_defaults.sas";
  %include "&fileloc./sea_ra_macro_rules.sas";
  %include "&fileloc./sea_ui_default.sas";
  %include "&fileloc./signal_position_ref.sas";
  %include "&fileloc./signal_type.sas";
  %include "&fileloc./status_type.sas";
  %include "&fileloc./subtype_group.sas";
  %include "&fileloc./trigger_type.sas";
  %include "&fileloc./unit_of_measure_ref.sas";
  %include "&fileloc./visit_type.sas";
DISCONNECT FROM ORACLE;
QUIT;
%MEND;
